<?xml version = "1.0" encoding = "UTF-8"?>

<!-- /* -->
<!--  * HCL Confidential -->
<!--  * (C) Copyright HCL Technologies Ltd. 2021.  All Rights Reserved. -->
<!--  * -->
<!--  *  The source code for this program is not published or otherwise -->
<!--  *  divested of its trade secrets, irrespective of what has been -->
<!--  *  deposited with the U.S. Copyright Office. -->
<!--  */ -->
<xsl:stylesheet version = "1.0" 
xmlns:xsl = "http://www.w3.org/1999/XSL/Transform">   
   <xsl:template match = "/"> 
    	
      <html> 
      	
      	<style>
			* {
			  box-sizing: border-box;
			}
			
			a { 
				text-decoration: none; 
			}
			
			body {
			  font-family: Arial, Helvetica, sans-serif;
			}
			
			/* Style the header */
			header {
			  background-color: #666;
			  padding: 2px;
			  text-align: left;
			  font-size: 20px;
			  color: white;
			  height: 10%;
			}
			
			/* Create two columns/boxes that floats next to each other */
			nav {
			  float: left;
			  width: 20%;
			  height: 100%; 
			  background: #ccc;
			  padding: 20px;
			}
			
			/* Style the list inside the menu */
			nav ul, #myUL {
			  list-style-type: none;
			  padding: 0;
			}
			
			article {
			  float: left;
			  padding: 20px;
			  width: 80%;  
			}
			
			
			section::after {
			  content: "";
			  display: table;
			  clear: both;
			}
			
			#myUL {
			  margin: 0;
			  padding: 0;
			}
			
			.caret {
			  cursor: pointer;
			  -webkit-user-select: none; 
			  -moz-user-select: none; 
			  -ms-user-select: none; 
			  user-select: none;
			}
			
			.caret::before {
			  content: "\25B6";
			  color: black;
			  display: inline-block;
			  margin-right: 6px;
			}
			
			.caret-down::before {
			  -ms-transform: rotate(90deg); 
			  -webkit-transform: rotate(90deg); 
			  transform: rotate(90deg);  
			}
			
			.nested {
			  display: none;
			}
			
			.active {
			  display: block;
			}
			
			.tab {
			  overflow: hidden;
			  border: 1px solid #ccc;
			  background-color: #f1f1f1;
			}
			
			
			.tab button {
			  background-color: inherit;
			  float: left;
			  border: none;
			  outline: none;
			  cursor: pointer;
			  padding: 14px 16px;
			  transition: 0.3s;
			  font-size: 17px;
			}
			
			
			.tab button:hover {
			  background-color: #ddd;
			}
			
			
			.tab button.active {
			  background-color: #ccc;
			}
			
			
			.tabcontent1 {
			  display: none;
			  padding: 6px 12px;
			  border: 1px solid #ccc;
			  border-top: none;
			}
			
			table td, table td * {
			    vertical-align: top;
			}
		</style>
	    <body> 
	
			<header>
			  <h2>CR Process Help</h2>
			</header>
			<section>
			    <nav>
			      <ul id="myUL">	      
				      <li><a href="#" class="tablinks" onclick="displayInfo(event, 'Welcome')" id="defaultOpen">Welcome</a></li>
				      <li><a href="#" class="tablinks" onclick="displayInfo(event, 'GlossaryofTerms')">Glossary of Terms</a></li>
				      <li><a href="#" class="tablinks" onclick="displayInfo(event, 'ListofAttributes')">List of Attributes</a></li>
				      <li><a href="#" class="tablinks" onclick="displayInfo(event, 'UserPreference')">User Preference</a></li>     
				      <li><a href="#" class="tablinks" onclick="displayInfo(event, 'processVisualizer')">Process Visualizer</a></li>
				      <li><a href="#" class="tablinks" onclick="displayInfo(event, 'SimpleProcessView')">Simple Process View</a></li>
			      
				  	  <li><span class="caret"><xsl:value-of select="CR_PROCESS/LIFE_CYCLE/NAME"/></span>
				    		<ul class="nested"> 
				      			<li><span class="caret">States</span>
					        		<ul class="nested">        
					        			<xsl:for-each select="CR_PROCESS/LIFE_CYCLE/STATE">
					          				<li>
					          					<xsl:element name="a">
					    							<xsl:attribute name="href">#</xsl:attribute>
					    							<xsl:attribute name="class">tablinks</xsl:attribute>	
											    	<xsl:attribute name="onclick">displayInfo(event, 'STATE<xsl:value-of select="NAME"/>')</xsl:attribute>
											    	<xsl:value-of select="LABEL"/>
				    							</xsl:element>
				    						</li>   
					    				</xsl:for-each>         
					                </ul>
				          		</li>
				          		<li><span class="caret">Transitions</span>
							        <ul class="nested">        
								        <xsl:for-each select="CR_PROCESS/LIFE_CYCLE/TRANSITION">
								          <li>
								          		<xsl:element name="a">
					    							<xsl:attribute name="href">#</xsl:attribute>
					    							<xsl:attribute name="class">tablinks</xsl:attribute>	
											    	<xsl:attribute name="onclick">displayInfo(event, 'TRANSITION<xsl:value-of select="NAME"/>')</xsl:attribute>
											    	<xsl:value-of select="LABEL"/>
				    							</xsl:element>
				    					  </li>    
								    	</xsl:for-each>  
							        </ul>
				      			</li>
						      	<li><span class="caret">Primary Transitions</span>
						        	<ul class="nested">        
						        		<xsl:for-each select="CR_PROCESS/LIFE_CYCLE/TRANSITION">
						    				<xsl:choose>
						    					<xsl:when test="PRIMARY_TRANSITION='true'">
							        				<li>
								        				<xsl:element name="a">
							    							<xsl:attribute name="href">#</xsl:attribute>
							    							<xsl:attribute name="class">tablinks</xsl:attribute>	
													    	<xsl:attribute name="onclick">displayInfo(event, 'TRANSITION<xsl:value-of select="NAME"/>')</xsl:attribute>
													    	<xsl:value-of select="LABEL"/>
					    								</xsl:element>
				    								</li> 	    	         
						      					</xsl:when>   
						    				</xsl:choose>
					    				</xsl:for-each>  
						        	</ul>
						      	</li>
				        	</ul>	        
				    </li>
			   </ul>
			  </nav>
			 <script><![CDATA[
			
					function displayInfo(evt, nameX) {
			           var i, tabcontent, tablinks;
			  		   tabcontent = document.getElementsByClassName("tabcontent");
			  		   for (i = 0; i < tabcontent.length; i++) {
			    			tabcontent[i].style.display = "none";
			  		   }
			  		   tablinks = document.getElementsByClassName("tablinks");
			  		   for (i = 0; i < tablinks.length; i++) {
			    			tablinks[i].className = tablinks[i].className.replace(" active", "");
			  		   }
			  		   document.getElementById(nameX).style.display = "block";
			  		   evt.currentTarget.className += " active";
			          } 
			          
			          function displayData(evt, nameX) {
						  var i, tabcontent, tablinks;
						  tabcontent = document.getElementsByClassName("tabcontent1");
						  for (i = 0; i < tabcontent.length; i++) {
						    tabcontent[i].style.display = "none";
						  }
						  tablinks = document.getElementsByClassName("tablinks");
						  for (i = 0; i < tablinks.length; i++) {
						    tablinks[i].className = tablinks[i].className.replace(" active", "");
						  }
						  document.getElementById(nameX).style.display = "block";
						  evt.currentTarget.className += " active";
					  }   
					 
					  
					  var toggler = document.getElementsByClassName("caret");
					  var i;
			
					  for (i = 0; i < toggler.length; i++) {
			  				toggler[i].addEventListener("click", function() {
			    		    	this.parentElement.querySelector(".nested").classList.toggle("active");
			    				this.classList.toggle("caret-down");
			  			    });
					  }
			 ]]>
			</script>
			  
			  <article id="Welcome" class="tabcontent" >  <!-- content for welcome -->
			       <p><xsl:value-of select="CR_PROCESS/DESCRIPTION"/></p>
			  </article>
			
			  <article id="GlossaryofTerms" class="tabcontent" style="display: none;"> <!-- hard-coded content for Glossary of Terms -->
			    <h2>Glossary of Terms</h2>
			    <h1>Attribute Security</h1>
			    <p>Attribute security on a state defines a list of attributes that are modifiable when the change request is in the selected state and the value of a 
			    	specific attribute matches the user ID(e.g. resolver="tom" or enterer="pam"). For attribute security to make sense, the selected attribute should 
			    	be one that holds a user ID as its value. If a role is specified as well, BOTH conditions must be met to modify the attribute list: the attribute 
			    	value must equal the user ID AND the user must have the specified role. </p>
			    <h1>Role Security</h1>
			    <p>Attribute security on a transition permits a user to perform the transition if the attribute value matches the user ID (for example, resolver="chris"
			     or verifier="natalie"). For attribute security to make sense, the selected attribute should be one that holds a user ID as its value. If a role is 
			     specified as well, BOTH conditions must be met to transiton the change request: the attribute value must equal the user ID AND the user must have the 
			     specified role.</p>
			     <p>Role security on a transition defines the roles which are allowed to perform the transition. For instance, if the verifier role is specified for the
			      entered2in_review transition, then a user with the verifier role may perform that transition.</p>
			    <h1>Branch Security</h1>
			    <p>Role security on a state defines a list of attributes that are modified when the change request is in the selected state and the user has the required 
			       role. For instance, if the verifier role has synopsis and description listed as modifiable attributes for the in_review state, then if user "sam" has 
			       the verfier role, he can modify those attributes when the change request is in_review state.</p>
			      <p>Branch security on a transition determines the validity of the transition based on an attribute and its value (for example, the attribute request_type
			       equals "defect"). Branch security is always applied, so even if another security rule has been satisfied, the branch rule(s) must also be met for the 
			       transition to be permitted. If a role is specified as well, BOTH conditions must be met to transition the change request: the chosen attribute value must
			        be equal AND the user must have the specified role. </p>    
			   </article>
			  <article id="ListofAttributes" class="tabcontent" style="display: none;">
				<h2>Attribute List</h2>
				<table border="1">
				    <tr>
				      <th>Name</th>
				      <th>Queriable</th>
				      <th>Reportable</th>
				      <th>Description</th>
				    </tr>
				    <xsl:for-each select="CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
					    <tr>
					      <td><xsl:value-of select="ALIAS"/></td>
					      <td><xsl:value-of select="QUERY_ATTRIBUTE"/></td>
					      <td><xsl:value-of select="REPORT_ATTRIBUTE"/></td>
					      <td><xsl:value-of select="DESCRIPTION"/></td>
					    </tr>
				    </xsl:for-each>
			  </table>		    
			  </article>
			  <article id="UserPreference" class="tabcontent" style="display: none;">
				<h2>Attribute List</h2>
				<table border="1">
				    <tr>
				      <th>Name</th>
				      <th>Queriable</th>
				      <th>Reportable</th>
				      <th>Description</th>
				    </tr>
				    <xsl:for-each select="CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
					    <xsl:choose>
					    	<xsl:when test="USER_PREF_ATTRIBUTE='true'">
						         <tr>
								      <td><xsl:value-of select="ALIAS"/></td>
								      <td><xsl:value-of select="QUERY_ATTRIBUTE"/></td>
								      <td><xsl:value-of select="REPORT_ATTRIBUTE"/></td>
								      <td><xsl:value-of select="DESCRIPTION"/></td>
						    	</tr>         
					      </xsl:when>   
					    </xsl:choose>
				    </xsl:for-each>
			  </table>		    
			  </article>
			  <article id="processVisualizer" class="tabcontent" style="display: none;">
				  <button class="tablinks" onclick="displayInfo(event, 'processVisualizer')">Default Lifecycle</button>
				  		<img src="fullProcess.jpg"  />
				  		<br/><br/><br/><br/><br/><br/><br/><br/><br/><br/>
				  <button class="tablinks" onclick="displayInfo(event, 'processVisualizer')">Reset to Start State</button><button class="tablinks" onclick="displayInfo(event, 'showOnlyPrimary')">Show Only Primary Transition</button>
			  
			  </article >
			  <article id="showOnlyPrimary" class="tabcontent" style="display: none;">
				  <button class="tablinks" onclick="displayInfo(event, 'processVisualizer')">Default Lifecycle</button>
				  		<img src="primaryTransition.jpg"  />
				  <br/><br/><br/><br/><br/><br/><br/><br/><br/><br/>
				  <button class="tablinks" onclick="displayInfo(event, 'processVisualizer')">Reset to Start State</button><button class="tablinks" onclick="displayInfo(event, 'showOnlyPrimary')">Show Only Primary Transition</button>
				  
			  </article>			  
			  <article id="SimpleProcessView" class="tabcontent" style="display: none;"> <!-- hard-coded content for Glossary of Terms -->
			    	<img src="processHelp.gif"  />    
			  </article>
			   
			  <xsl:for-each select="CR_PROCESS/LIFE_CYCLE/STATE">	
			    
				    <xsl:element name="article">
				    	<xsl:attribute name="id">STATE<xsl:value-of select="NAME"/></xsl:attribute>
				    	<xsl:attribute name="class">tabcontent</xsl:attribute>	
				    	<xsl:attribute name="style">display: none;</xsl:attribute>
				    	<xsl:value-of select="/CR_PROCESS/LIFE_CYCLE/NAME"/> -> States -> <xsl:value-of select="LABEL"/> (<xsl:value-of select="NAME"/>)
				    	 <!-- Tab links -->
							<div class="tab">
								<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'A<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Description</a>
				    			</xsl:element>
								<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'B<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Associations</a>
				    			</xsl:element>				
							</div>							
							<xsl:element name="div">
							    	<xsl:attribute name="id">A<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>				    	
							    	<xsl:value-of select="DESCRIPTION"/>
				    		</xsl:element>							
							<xsl:variable name="stateName">
							  <xsl:value-of select="NAME"/>
							</xsl:variable>
							<xsl:element name="div">
							    	<xsl:attribute name="id">B<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>	
							    		<table border="1">
								    		<tr>	
								    		<td>	    	
											<table border="1">	
									    		<tr>
									    			<th>Origin State</th><th>Transition</th>
									    		</tr>	
									    		<tr>
									    			<td>
									    			<table border="1">
									    				<xsl:for-each select="/CR_PROCESS/LIFE_CYCLE/TRANSITION">
												    		<xsl:if test="TO_STATE = $stateName">
													    		<xsl:variable name="fromState">
																  <xsl:value-of select="FROM_STATE"/>
																</xsl:variable>
														         
														         <xsl:for-each select="/CR_PROCESS/LIFE_CYCLE/STATE">
														         		<xsl:if test="NAME = $fromState">
														         			<tr>
																	        	 <td><xsl:value-of select="LABEL"/>	</td>									      
																	    	</tr>	
														         		</xsl:if>		
														         </xsl:for-each>
														         
														         
														                
												     		 </xsl:if>
											   			 </xsl:for-each>
									    			</table>
									    			</td>
									    			<td>
									    			<table border="1">
									    				<xsl:for-each select="/CR_PROCESS/LIFE_CYCLE/TRANSITION">
												    		<xsl:if test="TO_STATE = $stateName">
													         	<tr>
															      <td><xsl:value-of select="LABEL"/></td>										      
													    	     </tr>    
												     		 </xsl:if>
											   			 </xsl:for-each>
											   		</table>
									    			</td>
									    		</tr>				    
											    
										  </table>
										  </td>
										  
											<td><img src="stateAndTransitions2.png"  /> </td>
											<td>
									    	<table border="1">	
									    		<tr>
									    			<th>Transition</th>
									    		</tr>					    
											    <xsl:for-each select="/CR_PROCESS/LIFE_CYCLE/TRANSITION">
												    <xsl:if test="FROM_STATE = $stateName">
													         <tr>
															      <td><xsl:value-of select="LABEL"/></td>										      
													    	</tr>         
												      </xsl:if>
											    </xsl:for-each>
										  </table>
										  </td>
										  </tr>
							    	</table>
				    		</xsl:element>
							
							<div class="tab">
								<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'S_RAT<xsl:value-of select="NAME"/>')</xsl:attribute>						    	
							    	<a>Required Attributes(<xsl:value-of select="count(./REQ_FIELD/ATTRIBUTE)"/>)</a>
				    			</xsl:element>
								<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'S_OAT<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Optional Attributes(<xsl:value-of select="count(./OPT_FIELD/ATTRIBUTE)"/>)</a>
				    			</xsl:element>	
				    			<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'S_ROA<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Read Only Attributes(<xsl:value-of select="count(./READ_ONLY_FIELD/ATTRIBUTE/NAME[not(starts-with(., '{'))])"/>)</a>
				    			</xsl:element>
								<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'S_SEC<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Security</a>
				    			</xsl:element>
							</div>
							
							<xsl:element name="div">
							    	<xsl:attribute name="id">S_RAT<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>	
							    		<table border="1">	
									    		<tr>
									    			<th>Alias</th><th>Name</th><th>Description</th>
									    		</tr>	
									    		 
									    		<xsl:for-each select="./REQ_FIELD/ATTRIBUTE">
											    	<xsl:variable name="attrName">
													  <xsl:value-of select="NAME"/>
													</xsl:variable>
													  
													<xsl:for-each select="/CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
													    <xsl:if test="NAME = $attrName">
														         <xsl:variable name="attrAlias">
																  <xsl:value-of select="ALIAS"/>
																</xsl:variable>   
																<xsl:variable name="attrDesc">
																  <xsl:value-of select="DESCRIPTION"/>
																</xsl:variable>  
																<tr>
																	<td><xsl:copy-of select="$attrAlias" /></td>
															        <td><xsl:value-of select="NAME"/></td>
															        <td><xsl:value-of select="$attrDesc" /></td>	
														      </tr>     
													      </xsl:if>
													      
												    </xsl:for-each>
										    </xsl:for-each>			
										</table>			  
				    		</xsl:element>	
							
							
							<xsl:element name="div">
							    	<xsl:attribute name="id">S_OAT<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>	
							    		<table border="1">	
									    		<tr>
									    			<th>Alias</th><th>Name</th><th>Description</th>
									    		</tr>	
									    		
									    		<xsl:for-each select="./OPT_FIELD/ATTRIBUTE">
											    	<xsl:variable name="attrName">
													  <xsl:value-of select="NAME"/>
													</xsl:variable>
													  
													<xsl:for-each select="/CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
													    <xsl:if test="NAME = $attrName">
														         <xsl:variable name="attrAlias">
																  <xsl:value-of select="ALIAS"/>
																</xsl:variable>   
																<xsl:variable name="attrDesc">
																  <xsl:value-of select="DESCRIPTION"/>
																</xsl:variable>  
																<tr>
																	<td><xsl:copy-of select="$attrAlias" /></td>
															        <td><xsl:value-of select="NAME"/></td>
															        <td><xsl:value-of select="$attrDesc" /></td>	
														      </tr>     
													      </xsl:if>
													      
												    </xsl:for-each>
										    </xsl:for-each>			
										</table>			  
				    		</xsl:element>	
				    		
				    		
				    		<xsl:element name="div">
							    	<xsl:attribute name="id">S_ROA<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>	
							    		<table border="1">	
									    		<tr>
									    			<th>Alias</th><th>Name</th><th>Description</th>
									    		</tr>	
									    		
									    		<xsl:for-each select="./READ_ONLY_FIELD/ATTRIBUTE">
											    	<xsl:variable name="attrName">
													  <xsl:value-of select="NAME"/>
													</xsl:variable>
													  
													<xsl:for-each select="/CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
													    <xsl:if test="NAME = $attrName">
														         <xsl:variable name="attrAlias">
																  <xsl:value-of select="ALIAS"/>
																</xsl:variable>   
																<xsl:variable name="attrDesc">
																  <xsl:value-of select="DESCRIPTION"/>
																</xsl:variable>  
																<tr>
																	<td><xsl:copy-of select="$attrAlias" /></td>
															        <td><xsl:value-of select="NAME"/></td>
															        <td><xsl:value-of select="$attrDesc" /></td>	
														      </tr>     
													      </xsl:if>
													      
												    </xsl:for-each>
										    </xsl:for-each>			
										</table>			  
				    		</xsl:element>	
				    		
				    		<xsl:element name="div">
							    	<xsl:attribute name="id">S_SEC<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>	
							    		<table border="1">
								    		<tr>
								    			<td colspan="2" style="background-color:#00b3b3">By Attribute</td>
								    		</tr>
								    		<tr>
									    		<td>
									    			<table border="1">
									    			<tr>
									    				<th>Attribute</th><th>Role</th>
									    			</tr>
									    			<xsl:for-each select="./ATTR_SECURITY">
											    		<td><xsl:value-of select="NAME"/></td>
											    		<td><xsl:value-of select="ROLE"/></td>
											    	</xsl:for-each>				    		
									    			</table>
									    		</td>
								    			<td>
								    		   		Modifiable Attribute
									    			<table border="1">	
											    		<tr>
											    			<th>Name</th><th>Description</th>
											    		</tr>	
											    		
											    		<xsl:for-each select="./ATTR_SECURITY/ATTRIBUTE">						    		
													    	<xsl:variable name="attrName">
															  <xsl:value-of select="NAME"/>
															</xsl:variable>
															  
															<xsl:for-each select="/CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
															    <xsl:if test="NAME = $attrName">
																         <xsl:variable name="attrAlias">
																		  <xsl:value-of select="ALIAS"/>
																		</xsl:variable>   
																		<xsl:variable name="attrDesc">
																		  <xsl:value-of select="DESCRIPTION"/>
																		</xsl:variable>  
																		<tr>
																			<td><xsl:copy-of select="$attrAlias" /></td>												        
																	        <td><xsl:value-of select="$attrDesc" /></td>	
																      </tr>     
															      </xsl:if>
															      
														    </xsl:for-each>
												    	</xsl:for-each>			
													</table>
												</td>
								    		</tr>
								    	
							    		<tr>
							    			<td colspan="2" style="background-color:#00b3b3" >By Role</td>
							    		</tr>
							    		<tr>
							    			<td colspan="2">			    			
									    		<table border="1">
									    			<tr>
										    			<th>Role Name</th><th>Attribute Description</th>
										    		</tr>
									    		  <xsl:for-each select="./ROLE_SECURITY">
									    		  <tr>
									    			<xsl:for-each select=".">
									    				<td style="vertical-align:middle">
												    		<table border="1">
												    			<tr>
												    				<xsl:value-of select="NAME" />
												    			</tr>						    		
												    		</table>
											    		</td>
									    			</xsl:for-each>
									    			<td >
									    			<table border="1">	
										    			<xsl:for-each select="./ATTRIBUTE">
										    			
										    			
										    				<xsl:variable name="attrName">
															  <xsl:value-of select="NAME"/>
															</xsl:variable>
														  
														<xsl:for-each select="/CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
														    <xsl:if test="NAME = $attrName">
															         <xsl:variable name="attrAlias">
																	  <xsl:value-of select="ALIAS"/>
																	</xsl:variable>   
																	<xsl:variable name="attrDesc">
																	  <xsl:value-of select="DESCRIPTION"/>
																	</xsl:variable>  
																	<tr>
																		<td><xsl:copy-of select="$attrAlias" /></td>												        
																        <td><xsl:value-of select="$attrDesc" /></td>	
															      </tr>     
														      </xsl:if>
														      
													    </xsl:for-each>
										    			</xsl:for-each>	
									    			</table>
									    			</td>
									    			</tr>
									    			</xsl:for-each>	
									    		</table>
									    	</td>
							    		</tr>
							    		</table>							    		
				    		</xsl:element>
				    </xsl:element>
				    
			    </xsl:for-each>
			    
			    
			    <xsl:for-each select="CR_PROCESS/LIFE_CYCLE/TRANSITION">	
			    
				    <xsl:element name="article">
				    	<xsl:attribute name="id">TRANSITION<xsl:value-of select="NAME"/></xsl:attribute>
				    	<xsl:attribute name="class">tabcontent</xsl:attribute>	
				    	<xsl:attribute name="style">display: none;</xsl:attribute>
				    	<xsl:value-of select="/CR_PROCESS/LIFE_CYCLE/NAME"/> -> Transition -> <xsl:value-of select="LABEL"/> (<xsl:value-of select="NAME"/>)
				    	 <!-- Tab links -->
							<div class="tab">
								<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'AT<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Description</a>
				    			</xsl:element>
							</div>
							
							
							<xsl:element name="div">
							    	<xsl:attribute name="id">AT<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>				    	
							    	<xsl:value-of select="DESCRIPTION"/>
				    		</xsl:element>
			
							
							<xsl:variable name="stateName">
							  <xsl:value-of select="NAME"/>
							</xsl:variable>
							
							<div class="tab">
								<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'T_RAT<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Required Attributes(<xsl:value-of select="count(./REQ_FIELD/ATTRIBUTE)"/>)</a>
				    			</xsl:element>
								<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'T_OAT<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Optional Attributes(<xsl:value-of select="count(./OPT_FIELD/ATTRIBUTE)"/>)</a>
				    			</xsl:element>	
				    			<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'T_ROA<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Read Only Attributes(<xsl:value-of select="count(./READ_ONLY_FIELD/ATTRIBUTE/NAME[not(starts-with(., '{'))])"/>)</a>
				    			</xsl:element>
								<xsl:element name="button">
							    	<xsl:attribute name="class">tablinks</xsl:attribute>
							    	<xsl:attribute name="onclick">displayData(event, 'T_SEC<xsl:value-of select="NAME"/>')</xsl:attribute>					    	
							    	<a>Security</a>
				    			</xsl:element>
							</div>
							
							<xsl:element name="div">
							    	<xsl:attribute name="id">T_RAT<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>	
							    		<table border="1">	
									    		<tr>
									    			<th>Alias</th><th>Name</th><th>Description</th>
									    		</tr>	
									    		 
									    		<xsl:for-each select="./REQ_FIELD/ATTRIBUTE">
											    	<xsl:variable name="attrName">
													  <xsl:value-of select="NAME"/>
													</xsl:variable>
													  
													<xsl:for-each select="/CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
													    <xsl:if test="NAME = $attrName">
														         <xsl:variable name="attrAlias">
																  <xsl:value-of select="ALIAS"/>
																</xsl:variable>   
																<xsl:variable name="attrDesc">
																  <xsl:value-of select="DESCRIPTION"/>
																</xsl:variable>  
																<tr>
																	<td><xsl:copy-of select="$attrAlias" /></td>
															        <td><xsl:value-of select="NAME"/></td>
															        <td><xsl:value-of select="$attrDesc" /></td>	
														      </tr>     
													      </xsl:if>
													      
												    </xsl:for-each>
										    </xsl:for-each>			
										</table>			  
				    		</xsl:element>	
							
							
							<xsl:element name="div">
							    	<xsl:attribute name="id">T_OAT<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>	
							    		<table border="1">	
									    		<tr>
									    			<th>Alias</th><th>Name</th><th>Description</th>
									    		</tr>	
									    		
									    		<xsl:for-each select="./OPT_FIELD/ATTRIBUTE">
											    	<xsl:variable name="attrName">
													  <xsl:value-of select="NAME"/>
													</xsl:variable>
													  
													<xsl:for-each select="/CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
													    <xsl:if test="NAME = $attrName">
														         <xsl:variable name="attrAlias">
																  <xsl:value-of select="ALIAS"/>
																</xsl:variable>   
																<xsl:variable name="attrDesc">
																  <xsl:value-of select="DESCRIPTION"/>
																</xsl:variable>  
																<tr>
																	<td><xsl:copy-of select="$attrAlias" /></td>
															        <td><xsl:value-of select="NAME"/></td>
															        <td><xsl:value-of select="$attrDesc" /></td>	
														      </tr>     
													      </xsl:if>
													      
												    </xsl:for-each>
										    </xsl:for-each>			
										</table>			  
				    		</xsl:element>	
				    		<xsl:element name="div">
							    	<xsl:attribute name="id">T_ROA<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>	
							    		<table border="1">	
									    		<tr>
									    			<th>Alias</th><th>Name</th><th>Description</th>
									    		</tr>	
									    		
									    		<xsl:for-each select="./READ_ONLY_FIELD/ATTRIBUTE">
											    	<xsl:variable name="attrName">
													  <xsl:value-of select="NAME"/>
													</xsl:variable>
													  
													<xsl:for-each select="/CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
													    <xsl:if test="NAME = $attrName">
														         <xsl:variable name="attrAlias">
																  <xsl:value-of select="ALIAS"/>
																</xsl:variable>   
																<xsl:variable name="attrDesc">
																  <xsl:value-of select="DESCRIPTION"/>
																</xsl:variable>  
																<tr>
																	<td><xsl:copy-of select="$attrAlias" /></td>
															        <td><xsl:value-of select="NAME"/></td>
															        <td><xsl:value-of select="$attrDesc" /></td>	
														      </tr>     
													      </xsl:if>
													      
												    </xsl:for-each>
										    </xsl:for-each>			
										</table>			  
				    		</xsl:element>	
				    		<xsl:element name="div">
							    	<xsl:attribute name="id">T_SEC<xsl:value-of select="NAME"/></xsl:attribute>
							    	<xsl:attribute name="class">tabcontent1</xsl:attribute>	
							    		<table border="1">
							    			<tr>
							    				<td>
							    					<table border="1">
							    						Role Security
							    						<tr>
							    							<th>Roles</th>
							    						</tr>
							    						<xsl:for-each select="./ROLE_SECURITY">
											    			<tr>
											    				<td><xsl:value-of select="NAME"/></td>
											    			</tr>								    		
											    		</xsl:for-each>				    					
							    					</table>				    				
							    				</td>
							    				<td>
							    					<table border="1">
							    						Attribute Security
							    						<tr>
							    							<th>Attribute</th>
							    							<th>Role</th>
							    						</tr>
							    						<xsl:for-each select="./ATTR_SECURITY">
											    			<tr>
											    				<td><xsl:value-of select="NAME"/></td>
											    				<td><xsl:value-of select="ROLE"/></td>
											    			</tr>								    		
											    		</xsl:for-each>				    					
							    					</table>
							    				
							    				</td>
							    				<td>
							    					<table border="1" >
							    						Branch Security
							    						<tr>
							    							<th>Attribute</th>
							    							<th>Condition</th>
							    							<th>Value</th>
							    							<th>Role</th>				    							
							    						</tr>
							    						<xsl:for-each select="./BRANCH_SECURITY">
											    			<tr>
											    				<xsl:variable name="attrName">
																  <xsl:value-of select="./ATTRIBUTE/NAME"/>
																</xsl:variable>
																  
																<xsl:for-each select="/CR_PROCESS/SOURCE_ATTRIBUTES/ATTRIBUTE">
																    <xsl:if test="NAME = $attrName">
																	         <xsl:variable name="attrAlias">
																			  <xsl:value-of select="ALIAS"/>
																			</xsl:variable>   
																			<xsl:variable name="attrDesc">
																			  <xsl:value-of select="DESCRIPTION"/>
																			</xsl:variable>  
																				<td><xsl:value-of select="$attrAlias"/></td>    
																      </xsl:if>
															    </xsl:for-each>
											    				<td><xsl:value-of select="EQUALITY"/></td>
											    				<td><xsl:value-of select="./ATTRIBUTE/VALUE"/></td>
											    				<td><xsl:value-of select="ROLE"/></td>
											    			</tr>								    		
											    		</xsl:for-each>				    					
							    					</table>
							    				</td>			    			
							    			</tr>			    		
							    		</table>   		
				    		</xsl:element>
				    </xsl:element>    
			    </xsl:for-each>    
			</section>
        </body> 
      </html> 
   </xsl:template>  
</xsl:stylesheet>