<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri = "http://java.sun.com/jsp/jstl/functions"%>
<html>
<head>
<style type="text/css">
	@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/claro/claro.css";
	@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css";
	<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM name=styles/default_admin.css -->
		<!-- /WSLET -->
	</change:wsletExpander>
	
	table.cellLeftStyle{}
	
	.cellLeftStyle td
	{
		padding-left: 4px;
		padding-right: 2px;
		vertical-align: middle;
	}
	.cellLeftStyle thead
	{
		background-color: silver;
		font-weight: bold;
	}
	
	.message-box
	{
		margin: 10px auto;
		border: 1px solid gray;
		background-color: #fff9b0;				
		padding: 5px;				
		text-align: center;
		width: 95%;
	}
</style>
<title>Report Result</title>
<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
<script>
dojo.require("dijit.Tooltip");

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM name=EventUtils.js -->
<!-- PARAM NAME=StyleUtils.js -->
<!-- PARAM NAME=domUtilities.js -->
<!-- PARAM NAME=ScrapeText.js -->
<!-- PARAM NAME=Zebra.js -->
<!-- PARAM name=GenericTableSorter.js -->
<!-- /WSLET -->
</change:wsletExpander>
var removedRows = new Array();
var projectWithGuid = new Array();

 function initializeSorting()
 {
	var tBody = document.getElementById("sort-data");
	
	//Only make the table sortable if there is data.
	/*if (tBody.rows.length > 0)
	{
		var tableSorter = new GenericTableSorter(tBody, gColumnValueFunctions, "odd-row");	
		removeRows(tBody);
		tableSorter.sortOnHeader(document.getElementById("sort-item"));
		addRowsAfterSorting(tBody, removedRows);
	}*/
 }

 var gColumnValueFunctions = [
   	function(row)
   	{
   		return ScrapeText.fromTextNodes(row.cells[0]);
   	},
   ];

 function showProject(guid)
 {
	 document.viewProject.guid.value = guid;
	 document.viewProject.submit();
	 parent.parent.parent.frames[0].showProjectTab();
 }

function removeRows(body)
{
	var resultRows = new Array();
	
	// Construcs a datastrucre (Array) if there 
	// is need to get new data. Otherwise just 
	// removes the rows. 
	for (var i = body.rows.length - 1, j = 0; i >= 0; i--)
	{
		if (body.rows[i].id.match(/^rowspan-id-/i) != null) 
		{
			alert("Removing row - " + body.rows[i].id);
			removedRows[j++] = body.removeChild(body.rows[i]);
		}
	}
	
	// Reverse the Array.
	for (var i = removedRows.length - 1, j = 0; i >= 0; i--)
	{
		resultRows[j++] = removedRows[i];
	}
	
	removedRows = resultRows;					
	
	return removedRows;
}

function addRowsAfterSorting(body, removedRows)
{
	for (var i = 0; i < body.rows.length; i++)
	{
		if (body.rows[i].id.match(/^rowspan-id-/i) != null)
		{
			continue;
		}
		
		var currNode = body.rows[i];
		var hasClass = StyleUtils.hasClass(currNode, "odd-row");
		var rowId = "rowspan-id-" + currNode.id;
		alert("Current node -" + currNode.id);
		// Add the row and stripe it. 
		for (var j = 0; j < removedRows.length; j++)
		{
			//alert(currNode.id);
			if (rowId == removedRows[j].id)
			{
				alert("inserting -> " + removedRows[j].id +  " before " + currNode.nextSibling.id);
				// insert the row
				body.insertBefore(removedRows[j], currNode.nextSibling);
				
				// Stripe body row.
				/*if (hasClass)
				{
					StyleUtils.addClass(removedRows[j], "odd-row");
				}
				else
				{
					StyleUtils.removeClass(removedRows[j], "odd-row");
				}*/
				
				currNode = removedRows[j];
			}
		}
	}		
}

function findAndShowProject(name)
{
	for (var i = 0; i < projectWithGuid.length; i++)
	{
		if (projectWithGuid[i].name == name)
		{
			showProject(projectWithGuid[i].guid);
			break;
		}
	}
}

function initializeProjectMap()
{
	<c:choose>
		<c:when test="${not empty projectWithGuid}">
			<c:forEach var="projectMap" items="${projectWithGuid}">
				var temp = new Object();
				temp.name = '${projectMap.key}';
				temp.guid = '${projectMap.value}';
				projectWithGuid.push(temp);
			</c:forEach>
		</c:when>
	</c:choose>
}


dojo.addOnLoad(initializeProjectMap);
</script>
</head>
<body CLASS="claro">
<table width="100%" cellspacing="0" cellpadding="0">
			<tbody>
				<tr>
					<td style="text-align: center;">
					</td>
					<td style="white-space: nowrap; text-align: right; width: 4%;">
						<button type="button" name="print" onclick="window.print();">
							<change:resource key="lbl00167"/>
						</button>
					</td>
				</tr>
			</tbody>
		</table>
<table style="width: 100%">
<tr>
	<td style="text-align: left;">
		<change:resource key="reportHeaderLbl">
			<change:param value="${reportName}"/> <!-- Reverted back -->
		</change:resource>		
	</td>
	<td style="text-align: right;">
		<change:resource key="dateHeaderLbl">
			<change:param value="${reportDate}"/>
		</change:resource>
	</td>
</tr>
</table>
<br/>
<c:set var="result" value="${data}"/>
<table class="cellLeftStyle" width="100%" cellspacing="0" cellpadding="4" border="1">
<thead>
			<tr>
				<td id="sort-item" width=10%>
					${headerCol1}
				</td>
				<td width=10%>
					${headerCol2}
				</td>
				<td width=80%>
					<change:resource key="privilegesOrRolesHeaderLbl"/>
				</td>
			</tr>
		</thead>
		<tbody id="sort-data">
<c:forEach var="reportData" items="${data}" varStatus="index">
	<c:set var="vals" value="${reportData.value}"/>
	<c:set var="rowspan" value="${fn:length(reportData.value)}"/>
	<c:choose>
	<c:when test="${not empty vals}">
		<tr id="result-${index.count}">
			<td rowspan="${fn:length(reportData.value) + 1}" style="text-align: left; width: 10%">
				<c:choose>
					<c:when test="${reportType == 'users'}">
						<change:javaScriptEscape value ="${reportData.key}" encoding ="true"/>
					</c:when>
					<c:otherwise>
						<a href="javascript: findAndShowProject('${reportData.key}')"><u>${reportData.key}</u></a>
					</c:otherwise>
				</c:choose>
			</td>
		</tr>
	</c:when>
	<c:otherwise>
		<tr>
			<td style="text-align: left; width: 10%">
				<c:choose>
					<c:when test="${reportType == 'users'}">
						<change:javaScriptEscape value = "${reportData.key}" encoding ="true"/>
					</c:when>
					<c:otherwise>
						<a href="javascript: findAndShowProject('${reportData.key}')"><u>${reportData.key}</u></a>
					</c:otherwise>
				</c:choose>
			</td>
			<td colspan="2">
				<change:resource key="noMatchesFoundForReports"/>
			</td>
		</tr>
	</c:otherwise>
	</c:choose>
		<c:choose>
			<c:when test="${not empty vals}">
			<c:forEach var="items" items="${vals}" varStatus="i">
			<c:set var="rowspan-id" value="none"/> 
				<c:choose>
					<c:when test="${rowspan > 0}">
						<c:set var="rowspan-id" value="${i.count}"/>
					</c:when>
				</c:choose>
				
				<tr id='<c:choose><c:when test="${i.count == 1}"></c:when><c:otherwise>rowspan-id-result-${index.count}</c:otherwise></c:choose>'>
					<td width="10%">
						<c:choose>
							<c:when test="${reportType == 'users'}">
								<a href="#" onclick="showProject('${items.projectGuid}')"><u>${items.itemName}</u></a>
							</c:when>
							<c:otherwise>
								${items.itemName}
							</c:otherwise>
						</c:choose>
					</td>
					<td width="80%">
					
					<c:forEach var="roles" items="${items.roles}" varStatus="j">														
						<c:choose>
							<c:when test="${not roles.isAPriv}">									
								<a href="#" id="${roles.roleId}">${roles.roleName}</a>								
								<span dojoType="dijit.Tooltip" connectId="${roles.roleId}">
									<c:forEach var="privs" items="${roles.privs}" varStatus="k">
										${privs}
										<c:if test="${!k.last}">,</c:if>
									</c:forEach> 
								</span>								
							</c:when>	
							<c:otherwise>								
								${roles.roleName}
							</c:otherwise>
						</c:choose>
						<c:if test="${!j.last}">,</c:if>
					</c:forEach>
					</td>
				</tr>
			</c:forEach>
			</c:when>
		</c:choose>
</c:forEach>
	</tbody>
</table>

<form name="viewProject" action="view_projects.do" target="project_view">
<input type="hidden" name="token" value="${token}"/>
<input type="hidden" name="guid" value=""/>
</form>

</body>
</html>