<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- forms\admin_framework\view_projects.jsp -->
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change"%>

<!-- /* -->
<!-- * IBM and/or HCL Confidential
<!-- * (C) Copyright IBM Corp. 2020.  All Rights Reserved.
<!-- * (C) Copyright HCL Technologies Ltd. 2021.  All Rights Reserved.
<!-- *
<!-- *  The source code for this program is not published or otherwise
<!-- *  divested of its trade secrets, irrespective of what has been
<!-- *  deposited with the U.S. Copyright Office.
<!-- */ -->

<html>
<head>
<title>Projects</title>
<link rel="stylesheet" type="text/css" href="<change:urlCreator webResource='JS'/>dojo/dijit/themes/claro/claro.css">

<style type="text/css">
	<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM NAME=styles/default.css -->
		<!-- /WSLET -->
	</change:wsletExpander>
		
	<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM NAME=styles/default.css -->
		<!-- PARAM NAME=styles/visual_table.css -->
		<!-- PARAM NAME=styles/shybox.css -->
		<!-- PARAM NAME=styles/note.css -->
		<!-- PARAM NAME=styles/available_users_groups.css -->
		<!-- PARAM NAME=styles/tabs.css -->
		<!-- /WSLET -->
	</change:wsletExpander>	

	<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM NAME=styles/bordered_tabs.css -->
		<!-- /WSLET -->
	</change:wsletExpander>	

	html, body {
		overflow: hidden;
		padding: 0;
		margin: 0;
		height: 100%;
		width: 100%;
	}
	
	#intro-text {
		text-align: center;
		xpadding-top: 50px;
	}
	
	img {
		vertical-align: middle;
	}
	
	td.label_decoration {
		text-align: right;
	}

	.users-list {
		width: 90%;
	}

	.last-clicked {
		font-weight: bold;
	}
	
	.dirty {
		color: red;
	}
	
	#project {
		padding: 4px;
	}
	
	.action-column {
		border-left: solid 1px gray;
	}
	
	.column-title {
		font-weight: bold;
		padding-bottom: 1em;
	}
	
	.new-section {
		margin-top: 22px;
	}
	
	table.visual-table {
		margin: .5em 0;
	}
	
	table.visual-table td {
		padding: 0.5em;
	}
	
	.note {
		width: 98%;
	}
	
	table td.or-rule {
		padding-left: 5em;
	}
	
	td, th {
		vertical-align: top;
	}
	
	td.label_decoration {
		padding-right: 7px;
	}
	
	.dim {
		color: gray;
	}
	
	.claro .dijitFolderOpened {
		background: url(<change:urlCreator webResource="PTIMAGES"/>cr_project_opened.png) no-repeat top left;
	}
	
	.claro .dijitTreeRow, .claro .dijitTreeContent {
		cursor: pointer;
	}
	
	.claro .dijitFolderClosed, .claro .dijitLeaf {
		background: url(<change:urlCreator webResource="PTIMAGES"/>cr_project.png) no-repeat top left;
	}
	
	a {
		color: #000066;
	}
	
	.or-node {
		position: relative;
		white-space: no-wrap;
		display: block;
		margin-bottom: 4px;
	}
		
	table tbody.inherited td {
		border: none;
		color: #636363;
	}
	
	table tbody.inherited {
		border-top: solid 1px #636363;
	}
	
	.barHeading {
		font-size: 100%;
		background-color: #DDD;
		margin-bottom: 10px;
		font-weight: bold;
		padding: 4px;
	}
	
	.claro .sidebar {
		width: 200px;
		background-color: #eee;
		<c:if test="${inUserInterface}">
			<%-- Lighter gray is used in Admin interface to make the extra Projects title and New link easier to see. In User interface, just use the existing, darker gray for consistency (though I think the lighter looks nicer).--%>
			background-color: #ddd;
		</c:if>
		padding: 7px 5px;
	}
	
	.sort-header {
		font-weight: bold;
	}
	
	.stacked-button {
		width: 9em;
	}

	.dialog-footer button {
		min-width: 6em;
	}
	
	hr {
		margin: 10px 0 15px 0;
	}
	
	.dijitDialogCloseIcon {
		display: none;
	}
	
	#group-search-button {
		margin-left: 9px;
	}
	
	#group-content, #user-content {
		height: 20em;
	}
	
	#user-or-group-search-chosen {
		height: 23em;
	}
	
	<%-- .hideTabs class can be used above a User/Group search to hide the tabs and always show User search. In our case, we also need to adjust the height of the right column to line up better. --%>
	.hideTabs #user-or-group-search-chosen {
		height: 21em;
	}
	
	#rules.hide-add-attribute .add-attribute {
		display: none;
	}
	
	.disabled-add-attribute {
		display: none;
	}
	
	#rules.hide-add-attribute .disabled-add-attribute {
		display: inline;
		color: gray;
	}
	
</style>

<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djconfig="parseOnLoad: true, isDebug: false"></script>

<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LdapGroupUtilsAjax.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LdapUserUtilsAjax.js"></script>

<script type="text/javascript">

var token = '${user.token}';
var role = '${user.role}';

<change:wsletExpander>
	<!-- WSLET CODE=PTDataListBox -->
	<!-- PARAM NAME=CCM_USER_PROFILE -->
	<!-- PARAM NAME=USER_LIST -->
	<!-- PARAM NAME=CCM_ONLOAD_DATA VALUE=USER_RESOLVERS -->
	<!-- PARAM NAME=JAVASCRIPT_IDENTIFIER VALUE=USER_RESOLVERS -->
	<!-- /WSLET -->
</change:wsletExpander>

// Global map of all attributes to their details (type, ...)
var gAttributeMap = ${attributeMapJson};

var PT_WEB = '<change:urlCreator webResource="PTWEB"/>';

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=domUtilities.js -->
	<!-- PARAM NAME=EventUtils.js -->
	<!-- PARAM NAME=SelectUtils.js -->
	<!-- PARAM NAME=StyleUtils.js -->
	<!-- PARAM NAME=Shybox.js -->
	<!-- PARAM NAME=TypeFragments.js -->
	<!-- PARAM NAME=TableSorter.js -->
	<!-- PARAM NAME=ScrapeText.js -->
	<!-- PARAM NAME=Zebra.js -->
	<!-- PARAM NAME=AvailableUsers.js -->
	<!-- PARAM NAME=AvailableGroups.js -->
	<!-- PARAM NAME=DwrCleanUp.js -->
	<!-- PARAM NAME=MessageFormat.js -->
	<!-- PARAM NAME=TabUtils.js -->
	<!-- /WSLET -->
</change:wsletExpander>

dojo.require('dojo.data.ItemFileWriteStore');
dojo.require('dijit.Tree');
dojo.require('dijit.Dialog');
dojo.require('dijit.form.Button');
dojo.require('dijit.layout.BorderContainer');
dojo.require('dijit.layout.ContentPane');
dojo.require('dojo.parser');
dojo.require('dojo.NodeList-fx');

</script>

<script type="text/javascript">

(function() {

	<%-- Shortcuts like prototype.js --%>
	var $ = dojo.byId;
	var $$ = dojo.query;
		
	// Speed up opening of tree nodes.
	dijit.defaultDuration = 100;
	
	// The attributes that are in in use in the projects.
	// Until we load a project, we don't know what the list is, so
	// start with the known built-in attributes.
	var gFavoriteAttributes = new FavoriteAttributes();
	
	// All the known project roles.
	var gRoles = ${roleNamesJson};
	var gPrivs = ${privsJson};
	

/*************
	<%-- copied from other (probably acl related) files. Need to do some code sharing. --%>
	**************/

	var MORE_ATTRIBUTES = 'com.ibm.rational.change.pseudo.more_attributes';
	var DIVIDER_VALUE = 'com.ibm.rational.change.pseudo.divider';
	var DIVIDER_TEXT = '-----';
	
	function drawValueWidget(attributeName, valueNode, initialValue)
	{
		var newValue;
	
		if (attributeName === MORE_ATTRIBUTES)
		{
			<%-- Should not get here --%>
			return;
		}
		else
		{
			var attribute = gAttributeMap[attributeName];
			
			var type = (attribute) ?
				attribute.type :
				'CCM_STRING';
			
			if (window.AclExport && attributeName == AclExport.ATTRIBUTE_NONE)
			{
				type = '{all}';
			}
	
			switch (type)
			{
				case '{all}':
					newValue = document.createDocumentFragment();
					break;
				case 'CCM_TOGGLE':
					newValue = TypeFragments.createListboxFragment(attribute.values, initialValue);
					break;
				case 'CCM_LISTBOX':
					if (attribute.isDependent)
					{
						newValue = TypeFragments.createShyboxFragmentWithListboxIconWithCustomId(attribute.values, initialValue, attributeName);
					}
					else
					{
						newValue = TypeFragments.createShyboxFragment(attribute.values, initialValue);
					}
					break;
				case 'CCM_VALUELISTBOX':
					newValue = TypeFragments.createValueListboxFragment(attribute.values);
					break;
				case 'CCM_USER':
					newValue = TypeFragments.createUserShyboxFragment(initialValue);
					break;
				default: // all others, e.g. CCM_STRING, CCM_TEXT
					newValue = TypeFragments.createTextFragment(initialValue);
			}
		}
	
		dojo.empty(valueNode);
		valueNode.appendChild(newValue);
	}

<%-- 
	/************end copied **************/
 --%>

	<%--
		Walks the parent and ancestors of a node until it finds
		an ancestor with a matching nodeName. Optionally
		also checks the class of the ancestor before accepting it.
	 --%>
	function ancestor(child, parentNodeName, withClass)
	{
		var parent = child.parentNode;
		while (parent)
		{
			if (parent.nodeName == parentNodeName.toUpperCase() &&
				(!withClass || dojo.hasClass(parent, withClass)))
			{
				return parent;
			}
			
			parent = parent.parentNode;
		}
	}
	
	<%-- Clear and re-adds zebra stripes to tables. --%>
	function stripeTables(id)
	{
		if (typeof id == 'undefined')
		{
			id = "rules";
		}
		
		var trStr = '#project-pane .striped > tbody#' + id +' > tr';
		var trNStr = '#project-pane .striped > tbody#' + id +' > tr:nth-child(even)';
		
		$$(trStr).removeClass('odd-row');
		$$(trNStr).addClass('odd-row');
	}
	
	<%-- Creates new member row with proper Roles. Does not insert into the table. --%>
	function newMemberRow()
	{
		var row = $('role-row-template').cloneNode(true);
		row.removeAttribute('id');
		$$(row).query('.role-select').forEach(function(select) {
			updateRoleSelect(select);
		});
		return row;
	}

	<%-- Creates a new attribute row with a proper value widget, etc. Does not insert into table. --%>
	function newAttributeRow()
	{
		var row = $('attribute-row-template').cloneNode(true);
		row.removeAttribute('id');
		
		// Insert into hidden table for now to make IE happy--.cells and more don't work outside of the DOM.
		$('attribute-table-template').appendChild(row);

		var attributeSelect = $$(row.cells[0]).query('.attribute-select')[0];
		
		gFavoriteAttributes.updateSelect(attributeSelect, null);
		
		var attribute = SelectUtils.getSelectedValue(attributeSelect);
		drawValueWidget(attribute, $$(row).query('.value-node')[0]);
		dojo.connect(attributeSelect, 'onchange', onChangeAttribute);

		return row;
	}
	
	<%--
		Adds a new animation method to dojo.NodeLists (resturned from dojo.query or $$)
		which performs a yellow fade effect on the selected nodes.
	 --%>
	dojo.NodeList.prototype.flashYellow = function() {
		this.style('backgroundColor', '#fff9b0');

		var self = this;
		return this.anim(
			{'backgroundColor': 'white'},
			500,
			null,
			function() { self.style('backgroundColor', ''); }
			);
	};

	<%-- Deletes a row from any table and set the project as dirty. --%>
	function deleteRow(row)
	{
		var deadRows = $$(row);

		//Main aim to get the id of the tbody
		//for which this row is part of, so that 
		//zebra stripes can be reconstructed again.
		var parentTbody = ancestor(row, 'tbody');
		setDirty(true);
		deadRows.orphan();
		stripeTables(parentTbody.id);
		return true;
	}
	
	<%-- 
		Attempts to select an attribute from and attribute SELECT
		that is not already in use.
		inUse - a set of attributes already being used.
		attributeSelect - the SELECT
	 --%>
	function selectUnusedAttribute(inUse, attributeSelect)
	{
		for (var i = 0; i < attributeSelect.options.length; i++)
		{
			var option = attributeSelect.options[i];
			if (option.value == DIVIDER_VALUE || option.value == MORE_ATTRIBUTES) continue;
			if (!inUse[option.value])
			{
				option.selected = true;
				attributeDidChange(attributeSelect);
				return;
			}
		}
	}
	<%--
		Adds a new attribute row after an existing row.
		Handles disabling in use attributes and selecting the
		best available attribute.
	--%>
	function addAttributeRow(afterRow)
	{
		// Get all attributes in use before we add this row
		var inUse = getInUseAttributes();

		var row = newAttributeRow();
		setDirty(true);
		
		if ($('rules').rows.length == 0)
		{
			// first rule
			$('rules').appendChild(row);
			$$('.minus', row).style('visibility', 'hidden');
		}
		else
		{
			dojo.place(row, afterRow, 'after');
		}
		stripeTables('rules');
		
		// IE needs this in a timeout or it leaves artifacts behind!
		if (dojo.isIE)
		{
			window.setTimeout(function() {
				hideBlankRule();
			}, 1);
		}
		else
		{
			hideBlankRule();
		}
		
		selectUnusedAttribute(inUse, $$('.attribute-select', row)[0]);
		
		$$('TD', row).flashYellow();
		enableDisableAttributes();
		var first = $$('INPUT', row)[0];
		first && first.focus();
		
	}
	
	<%-- Deletes an attribute row and updates the disabled attributes.--%>
	function deleteAttributeRow(row)
	{
		if (deleteRow(row))
		{
			if ($('rules').rows.length == 0)
			{
				showBlankRule();
			}
			else
			{
				enableDisableAttributes();
			}
		}
	}
	
	function addMemberRow(afterRow)
	{
		// IE needs this in a timeout or it leaves artifacts behind!
		window.setTimeout(function() {
			$('blank-role').style.display = 'none';
		}, 1);

		var row = newMemberRow();
		setDirty(true);
		
		if ($('roles').rows.length == 0)
		{
			// first role
			$('roles').appendChild(row);
		}
		else
		{
			dojo.place(row, afterRow, 'after');
		}
		
		stripeTables('roles');
		$$('TD', row).flashYellow();
		var first = $$('INPUT', row)[0];
		first && first.focus();

	}
	
	function deleteMemberRow(row)
	{
		if (deleteRow(row))
		{
			if ($('roles').rows.length == 0)
			{
				$('blank-role').style.display = '';
			}
		}
	}
	
	<%--
		Creates a new OR node outside the DOM.
		This is the HTML fragment that show a single value of an attribute
		and can have + and - signs by it.
	 --%>
	function cloneOrNode(forAttribute)
	{
		var newOrNode = $$('#attribute-row-template .or-node')[0].cloneNode(true);
		drawValueWidget(forAttribute, $$('.value-node', newOrNode)[0], '');
		return newOrNode;
	}
	
	<%-- 
		Adds a new OR value row after clicking a plus sign.
		plus - the element that was clicked: a plus.
	 --%>
	function addOrValue(plus)
	{
		setDirty(true);
		var orNode = ancestor(plus, 'SPAN', 'or-node');
		var row = ancestor(orNode, 'TR');
		
		// show (-) sign
		$$('.minus', row)[0].style.visibility = 'visible';

		// Create new value that matches the selected attribute
		var attrName = SelectUtils.getSelectedValue($$('.attribute-select', row)[0]);
		var newOrNode = cloneOrNode(attrName);
		$$('.or', newOrNode).style('visibility', 'visible');
		dojo.place(newOrNode, orNode, 'after');
		$$('.value-node input, .value-node select', newOrNode)[0].focus();
		$$(newOrNode).flashYellow();
	}
	
	<%-- 
		Removes and OR value after clicking a minus.
	 --%>
	function deleteOrValue(minus)
	{
		// Remove value.
		setDirty(true);
		var orNode = ancestor(minus, 'SPAN', 'or-node');
		var row = ancestor(orNode, 'TR');
		dojo.destroy(orNode);
		
		// Hide (-) if last one.
		var minuses = $$('.minus', row);
		if (minuses.length == 1) minuses[0].style.visibility = 'hidden';
		
		// Show all "or"s except the first.
		$$('.or', row).style('visibility', 'visible')[0].style.visibility = 'hidden';
	}
	
	
	<%-- 
		Handles clicks for various dynamically added elements on the page.
		Uses the 'class' of the element to decide which action to take.
		This is done instead of adding onclick handler to dynamically added
		elements. This is both easier (just need to add a class attribute)
		and is faster when there are huge number of elements (adding lots
		of events handler can be slow).
	 --%>
	function onClickDoc(e)
	{
		var target = e.target

		if (dojo.hasClass(target, 'add-attribute'))
		{
			dojo.stopEvent(e);
			addAttributeRow(ancestor(target, 'TR'));
		}
		else if (dojo.hasClass(target, 'delete-attribute'))
		{
			dojo.stopEvent(e);
			deleteAttributeRow(ancestor(target, 'TR'));
		}
		else if (dojo.hasClass(target, 'add-role'))
		{
			dojo.stopEvent(e);
			addMemberRow(ancestor(target, 'TR'));
		}
		else if (dojo.hasClass(target, 'delete-role'))
		{
			dojo.stopEvent(e);
			deleteMemberRow(ancestor(target, 'TR'));
		}
		else if (dojo.hasClass(target, 'add-or-attribute'))
		{
			dojo.stopEvent(e);
			addOrValue(target);
		}
		else if (dojo.hasClass(target, 'delete-or-attribute'))
		{
			dojo.stopEvent(e);
			deleteOrValue(target);
		}
		else if (dojo.hasClass(target, 'find-users-groups'))
		{
			onFindUsersAndGroups(e);
		}
	}
	
	<%-- 
		Parse invisible 'inherited-attributes' form element
		to read them from the currently loaded project.
	 --%>
	function getInheritedAttributes()
	{
		var set = {};
		
		// From inherited_project_rules.jspf
		var inheritedInput = $('inherited-attributes');
		if (inheritedInput)
		{
			var inheritedAttributes = splitUsers(inheritedInput.value);
			for (var i = 0; i < inheritedAttributes.length; i++)
			{
				set[inheritedAttributes[i]] = true;
			}
		}
		
		return set;
	}
	
	<%-- Returns a set of all attribute already used, including inherited. --%>
	function getInUseAttributes()
	{
		var inUseAttributes = getInheritedAttributes();
		
		// Get all the attribute in use in the current project across all rules.
		$$('#rules .attribute-select').forEach(function(select) {
			var attribute = SelectUtils.getSelectedValue(select);
			if (attribute == MORE_ATTRIBUTES || attribute == DIVIDER_VALUE) return;
			
			inUseAttributes[attribute] = true;
		});
		
		return inUseAttributes;
	}
	
	<%--
		Enabled and disabled attribute name OPTIONS from attribute SELECTs
		so that al in-use attributes are grayed out.
	 --%>
	function enableDisableAttributes()
	{
		// Get all the attribute in use in the current project across all rules.
		var inUseAttributes = getInUseAttributes();
		
		// Now, for each row (rule) disable all the attributes
		// in use in other rows. I.e., an inUseAttribute that's not the selected
		// attribute for the row.
		var attributeRows = $$('#rules > tr');
		attributeRows.forEach(function(row) {
			var selects = $$('.attribute-select', row);
			// Blank row won't have a select on it.
			if (selects.length == 0) return;
			var select = selects[0];
			
			var selectedAttribute = SelectUtils.getSelectedValue(select);
			for (var i = 0; i < select.options.length; i++)
			{
				var attributeOption = select.options[i];
				var attribute = attributeOption.value;
				
				attributeOption.disabled = attribute == DIVIDER_VALUE ||
					(!attributeOption.selected && inUseAttributes[attribute]);
			}
		});
		
		if (attributeRows.length >= gFavoriteAttributes.favoriteList.length)
		{
			$$('#rules').addClass('hide-add-attribute');
		}
		else
		{
			$$('#rules').removeClass('hide-add-attribute');
		}
	}
	
	
	<%-- 
		Tracks the list of "favorite" attributes that the user sees in attribute
		selects. Initially, most are hidden. The user manually adds more, or
		we auto add ones as projects are loaded with some in use already.
		Handles adding More Attributes... entry to bottom of list.
	  --%>
	function FavoriteAttributes()
	{
		this.favoriteSet = {'problem_number': true};
		this.favoriteList = ['problem_number'];
		
		var self = this;
		<%-- Check for some common attribute that MIGHT be in the lifecycle and add them too. --%>
		dojo.forEach(['product_name', 'release'], function(optional) {
			if (gAttributeMap[optional])
			{
				self.favoriteSet[optional] = true;
				self.favoriteList.push(optional);
			}
		});
		
		this.favoriteList.sort();
	}
	
	FavoriteAttributes.prototype._updateSelects = function()
	{
		var self = this;
		$$('#rules .attribute-select').forEach(function(select)
		{
			self.updateSelect(select, null);
		});
	};
	
	<%-- Updates an attribute SELECT with the current list of fav attributes. --%>
	FavoriteAttributes.prototype.updateSelect = function(select, selectedAttribute, forFavoritesDialog)
	{	
		if (!forFavoritesDialog && !selectedAttribute)
		{
			// Get what's already selected if not selecting something new
			selectedAttribute = SelectUtils.getSelectedValue(select);
			// log('is ' + selectedAttribute);
		}
		
		select.options.length = 0;

		var selectedIndex = 0;
		for (var i = 0; i < this.favoriteList.length; i++)
		{
			var attribute = this.favoriteList[i];
			SelectUtils.addOption(select, attribute, attribute);
			
			if (!forFavoritesDialog && selectedAttribute == attribute)
			{
				selectedIndex = i;
			}
		}
		
		if (!forFavoritesDialog)
		{
			// Set test after creating all options or IE 6 selects the wrong entry
			select.lastSelectedIndex = selectedIndex;
			select.selectedIndex = selectedIndex;

			// Always present at bottom
			// ------
			// More....
			SelectUtils.addOption(select, DIVIDER_TEXT, DIVIDER_VALUE).disabled = true;
			
			SelectUtils.addOption(select, <change:resource js="true" key="moreAttributesAction"/>, MORE_ATTRIBUTES);
		}
		
		return select;
	};
	
	<%-- Sets the favority attribute. The old set is overwritten. --%>
	FavoriteAttributes.prototype.set = function(newAttributes)
	{
		this.favoriteSet = {};
		this.favoriteList = [];
		this.addAll(newAttributes);
	};

	<%-- Adds new favorites to current set. --%>
	FavoriteAttributes.prototype.addAll = function(newAttributes)
	{
		var dirty = false;
		var self = this;
		
		for (var i = 0; i < newAttributes.length; i++)
		{
			var name = newAttributes[i];
			if (!this.favoriteSet[name])
			{
				this.favoriteSet[name] = true;
				this.favoriteList.push(name);
				dirty = true;
			}
		}
		
		if (dirty)
		{
			this.favoriteList.sort();
			this._updateSelects();
		}
	}

	<%--
		Adds all the attributes used by a project to the current set.
		projectDiv - the HTML frag of a loaded project.
	 --%>
	FavoriteAttributes.prototype.addFromProject = function(projectDiv)
	{
		var dirty = false;
		var self = this;
		
		var attributes = [];

		$$(projectDiv).query('.attribute-select').forEach(function(select) {
			var value = SelectUtils.getSelectedValue(select);
			attributes.push(SelectUtils.getSelectedValue(select));
		});
		
		this.addAll(attributes);
	};

	gProjectIsDirty = false;
	gProjectIsNew = false;

	<%-- Marks project as dirty. Reddens the Save button. --%>
	function setDirty(dirty)
	{
		if (dirty)
		{
			gProjectIsDirty = true;
			$$('#save').addClass('dirty');
		}
		else
		{
			gProjectIsDirty = false;
			gProjectIsNew = false;
			$$('#save').removeClass('dirty');
		}

		hasModifications(dirty);
	}

	function showFavoriteAttributesDialog()
	{
		$('attribute-picker-available').selectedIndex = -1;
		gFavoriteAttributes.updateSelect($('attribute-picker-chosen'), null, true);
		dijit.byId('fav-attributes-dialog').show();
	}

	<%--
	Stores the last SELECT element clicked before showing More/Favorite attributes dialog.
	After the attributes are picked, we set the current attribute value of gLastSelect
	to be the newly added attribute.
	 --%>
	var gLastSelect;
	
	<%--
		Called after an attribute changes.
		Handle opening the Favorite Attribute dialog if needed.
		If a new attribute is selected, redraws the value widget for
		the attributes type.
	 --%>
	function attributeDidChange(attributeSelect)
	{
		if (attributeSelect.options[attributeSelect.selectedIndex].disabled)
		{
			attributeSelect.selectedIndex = attributeSelect.lastSelectedIndex;
			return;
		}
		
		var attribute = SelectUtils.getSelectedValue(attributeSelect);

		if (attribute == null)
		{
			return;
		}
		else if (attribute == MORE_ATTRIBUTES)
		{
			attributeSelect.selectedIndex = attributeSelect.lastSelectedIndex || 0;
			gLastSelect = attributeSelect;
			showFavoriteAttributesDialog(attributeSelect);
			return;
		}
		else if (attribute == DIVIDER_VALUE)
		{
			attributeSelect.selectedIndex = attributeSelect.lastSelectedIndex || 0;
			return;
		}

		// Really changed an attribute
		setDirty(true);
		enableDisableAttributes();
		attributeSelect.lastSelectedIndex = attributeSelect.selectedIndex;
		
		var row = ancestor(attributeSelect, 'TR');
		dojo.empty(row.cells[1]);
		row.cells[1].appendChild(cloneOrNode(attribute));

		<%-- Can't delete first value --%>
		$$('.minus', row).style('visibility', 'hidden');
		
		<%-- Toggles have only two states, so hide the ability to add more values --%>
		if (gAttributeMap[attribute].type == 'CCM_TOGGLE')
		{
			$$('.plus', row).style('visibility', 'hidden');
		}
	}

	function onChangeAttribute(e)
	{
		var attributeSelect = e.target;
		attributeDidChange(attributeSelect);
	}
	
	<%--
		Creates a new OPTGROUP element and populates it with a list
		of values for it OPTIONS.
		label - name of the opt group
		values - the values of the OPTIONs to add. Value is used for text and value of each option.
	 --%>
	function newOptGroup(label, values)
	{
		<%-- No JavaScript OptGroup, so create the nodes manually. --%>
		var group = dojo.create('OPTGROUP', {'label': label})
		
		for (var i = 0; i < values.length; i++)
		{
			var value = values[i];
			<%-- InnerHTML is used for the "text". --%>
			group.appendChild(dojo.create('OPTION', {
				'innerHTML': escapeHtml(value),
				'value': value
			}));
		}
		
		return group;
	}
	
	<%-- 
		Updates a SELECT to use the current  list of roles and privs,
		which are save in global variables.
	 --%>
	function updateRoleSelect(select)
	{
		var oldValue = SelectUtils.getSelectedValue(select);

		select.options.length = 0;
		select.innerHTML = '';
		select.appendChild(newOptGroup('<change:resource key="globalPrivsRoles"/>', gRoles));
		select.appendChild(newOptGroup('<change:resource key="globalPrivsPrivileges"/>', gPrivs));
		
		if (oldValue) SelectUtils.selectValue(select, oldValue, true);
	}
	
	function hideIntro()
	{
		$('intro').style.display = 'none';
	}
	
	function hideSpinner()
	{
		if (gLoadProjectTimeout) window.clearTimeout(gLoadProjectTimeout);
		$('spinner').style.display = 'none';
	}
	
	function showIntro()
	{
		hideSpinner();
		$('intro').style.display = '';
		$('save-pane').style.visibility = 'hidden';
		
		// These are shown an hidden and attached to the body
		// when a project is showing. Once the project is gone, destroy them.
		// They won't be used again.
		$$('select.shybox').orphan();
	}
	
	function showBlankRule()
	{
		$('blank-rule').style.display = '';
	}
	
	function hideBlankRule()
	{
		$('blank-rule').style.display = 'none';
	}
	
	function hideFindDialog()
	{
		dijit.byId('user-or-group-search-dialog').hide();
	}
	
	function onFindOk(e)
	{
		dijit.byId('user-or-group-search-dialog').findOkCallback();
	}
	
	function showFindUsersOrGroups(input, dialogTitle, availableListTitle, chosenListTitle, includeGroups)
	{
		// Set the "chosen" list to match the current values.
		//var users = splitUsers(input.value);
		var chosen = $('user-or-group-search-chosen');
		SelectUtils.clearList('user-or-group-search-chosen');
		var done = false;

		if ((input.id == 'editors') && (typeof editorsWithDisplayName != 'undefined') && editorsWithDisplayName.length > 0)
		{
			for (var i = 0; i < editorsWithDisplayName.length; i++)
			{
				SelectUtils.addOption(chosen, editorsWithDisplayName[i].displayName, editorsWithDisplayName[i].name, false);
			}

			done = true;
		}
		else if ((input.id == 'admins') && (typeof adminsWithDisplayName != 'undefined') && adminsWithDisplayName.length > 0)
		{
			for (var i = 0; i < adminsWithDisplayName.length; i++)
			{
				SelectUtils.addOption(chosen, adminsWithDisplayName[i].displayName, adminsWithDisplayName[i].name, false);
			}

			done = true;
		}
		else if ((input.id.indexOf('members_') > -1) && (typeof userWithDisplayName != 'undefined') && userWithDisplayName.length > 0)
		{
			for (var i = 0; i < userWithDisplayName.length; i++)
			{
				if (input.id.indexOf(userWithDisplayName[i].name) > -1)
				{
					SelectUtils.addOption(chosen, userWithDisplayName[i].displayName, userWithDisplayName[i].name, false);
				}
			}

			done = true;
		}
		
		if (!done)
		{
			SelectUtils.addValues(chosen, splitUsers(input.value));
		}

		//reset all previously set values to blank for source list 
		//while displaying a new popup dialog.
		clearGroupsOrUsersSourceList();
		disableOkButton(true);
		
		if (includeGroups)
		{
			$$('#user-or-group-search-dialog').removeClass('hideTabs');
		}
		else
		{
			$$('#user-or-group-search-dialog').addClass('hideTabs');
		}
		
		// Change the chosen list title to match this operation.
		$$('#user-or-group-search-available-title').empty().addContent(availableListTitle);
		$$('#user-or-group-search-chosen-title').empty().addContent(chosenListTitle);
		
		// When done, update the original input value to match.
		// This callback is always called by the normal "OK" handler.
		var dialog = dijit.byId('user-or-group-search-dialog');
		dialog.attr('title', dialogTitle);
		
		dialog.findOkCallback = function() {
			var newUsers = SelectUtils.getValues(chosen);
			input.value = newUsers.join(', ');
			hideFindDialog();
		};
		
		dijit.byId('user-or-group-search-dialog').show();
		
		// Since dijit.Dialog.show uses an animation the elements it wraps are not displayed yet.
		// Delay selecting the tab to ensure its  elements are "on the page" before working with them.
		window.setTimeout(function() {
			AvailableUsers.showSearch();
		}, 10);
		
	}

	/*
	* This method disables the 'OK' button in the popup.
	*
	* disable - if true, this will disable the button
	* and if false, button will be enabled.
	*/
	function disableOkButton(disable)
	{
		dojo.byId("ok-find").disabled = disable;
	}

	function clearGroupsOrUsersSourceList()
	{
		//Clear user source list.
		SelectUtils.clearList('user-search-results');
		$('user-search-text').value = "";

		//Now clear group source list data.
		SelectUtils.clearList('group-search-results');
		$('group-search-text').value = "";
		
	}
	
	function onFindAdmins(e)
	{
		dojo.stopEvent(e);
		showFindUsersOrGroups($('admins'),
			'<change:resource key="assignProjectAdmins"/>',
			'<change:resource key="availableUsers"/>',
			'<change:resource key="projectAdminsTitle"/>');
	}
	
	function onFindEditors(e)
	{
		dojo.stopEvent(e);
		showFindUsersOrGroups($('editors'),
			'<change:resource key="assignProjectEditors"/>',
			'<change:resource key="availableUsers"/>',
			'<change:resource key="projectEditorsTitle"/>');
	}
	
	function onFindUsersAndGroups(e)
	{
		dojo.stopEvent(e);
		var row = ancestor(e.target, 'tr');
		var input = $$('input', row.cells[0])[0];
		var role = $$('select', row.cells[1])[0].value;
		
		showFindUsersOrGroups(
			input,
			'<change:resource key="assignProjectMembers"/>',
			'<change:resource key="availableUsersAndGroups"/>',
			'<change:resource key="aclUsersAndGroupsHeader"/>', true);
	}
	
	<%--
		Takes a HTML fragment representing a project and adds it to the DOM.
		Handles connecting events and updating listboxes on the project
		to use the most recent values (e.g., favoriote attributes),
	--%>
	function showProjectHtml(html)
	{
		hideSpinner();
		hideIntro();
		
		// Kill any remnants of shyboxes from old projects. They get attached to the body
		// and not autoremoved.
		$$('select.shybox').orphan();
		
		$('save-pane').style.visibility = 'visible';
		
		// Create the DOM for the project off the visible page at first.
		var projectNode = document.createElement('div');
		dojo.attr(projectNode, 'id', 'project');
		dojo.style(projectNode, 'visibility', 'hidden');
		projectNode.innerHTML = html;
		
		$$('.value-node', projectNode).forEach(function(valueNode) {
			var value = valueNode.innerHTML;
			var name = dojo.attr(valueNode, 'initialName');
			drawValueWidget(name, valueNode, value);

		});
		
		var projectPane = $('project-pane');
		projectPane.replaceChild(projectNode, $('project'));
				
		var guidInput = $('guid');
		if (!guidInput) return false;
		var guid = guidInput.value;
		if (!guid) return false;
		var name = $('name').value;
		
		if ($('rules').rows.length == 0)
		{
			showBlankRule();
		}
		
		if ($('roles').rows.length == 0)
		{
			$('blank-role').style.display = '';
		}
		
		var project = $$(projectNode);
		
		// Collect new favorite (in use) attributes from the loaded project,
		// then update the attribute selects in the new project with these attributes.
		gFavoriteAttributes.addFromProject(project);

		project.query('.attribute-select').forEach(function(select) {
			select.lastSelectedIndex = select.selectedIndex;
			var value = SelectUtils.getSelectedValue(select);
			gFavoriteAttributes.updateSelect(select, value);
			dojo.connect(select, 'onchange', onChangeAttribute);
		});
		
		project.query('.role-select', project).forEach(function(select) {
			updateRoleSelect(select);
		});
		
		$$('#delete-project').onclick(onDeleteProject);
		$$('#new-subproject').onclick(onNewSubproject);
		
		$$('select, input').onchange(function(e) {
			setDirty(true);
		});
		
		var isAdmin = 'true' == $('is-admin').value;
		var isEditor = 'true' == $('is-editor').value;
		var selects = ScrapeText.fromSelects;
		var inputs = ScrapeText.fromInputs;
		var text = ScrapeText.fromTextNodes;
		
		new TableSorter($('rules'), [
			function(tr) { return isAdmin ? selects(tr.cells[0]) : text(tr.cells[0]); },
			function(tr) { return isAdmin ? inputs(tr.cells[1]) : text(tr.cells[1]); }
		], 'odd-row');
		
		new TableSorter($('roles'), [
			function(tr) { return isEditor ? inputs(tr.cells[0]) : text(tr.cells[0]); },
			function(tr) { return isEditor ? selects(tr.cells[1]) : text(tr.cells[1]); },
		], 'odd-row');
		
		$$('#find-admins').onclick(onFindAdmins);
		$$('#find-editors').onclick(onFindEditors);
		
		$('save').disabled = !isAdmin && !isEditor;
		
		enableDisableAttributes();
		
		dojo.style(projectNode, 'visibility', 'visible');

		// Execute the embeded java script.
		evaluateJavaScriptContent(html);
		
		return true;
	}

	/*
	* Evaluates the java script content embeded within the result returned.
	* This is needed for IE, as IE does not execute them by default.
	*/
	function evaluateJavaScriptContent(html)
	{
		if(window.execScript)
		{
			var start = html.indexOf('<script>');
			var end = html.indexOf("<\/script>");
			var script = html.substring(start + 8, end);
		
			window.execScript(script);
		}
	}
	
	function onGenericXhrError(error)
	{
		hideSpinner();
		alert(error.responseText);
	}
	
	<%-- Timeout handled to clear the project pane and show a spinner. We only do this if the project takes a while to load so that we can avoid flashing the project pane is the project will load fast anyway. This must be canceled when a project finally loads. --%>
	var gLoadProjectTimeout;
	
	<%--
		Ajax call to load a project and show it.
		extraCallbackAfterShow - function to run after the project has been show. Optional.
	 --%>
	function loadProjectByGuid(guid, extraCallbackAfterShow)
	{
		gLoadProjectTimeout = window.setTimeout(function() {
			$('project').innerHTML = '';
			$('spinner').style.display = '';
		}, 250);
		
		dojo.xhrGet({
			url: '<c:url value="/project.do"/>',
			content: {'guid': guid, 'token': '${user.token}' },
			load: function(html) {
				showProjectHtml(html);
				if (extraCallbackAfterShow) extraCallbackAfterShow();
				},
			error: onGenericXhrError
		});
	}
	
	function changeProject(item)
	{
		loadProjectByGuid(item.guid);
	}
	
	function onDeleteProject(e)
	{
		dojo.stopEvent(e);
		
		var guid = $('guid').value;
		var name = $('name').value;
		if (!guid) return;
		
		if (!gProjectIsNew || gProjectIsDirty)
		{
			<%-- Do not confirm for new projects --%>
			var m = new MessageFormat(<change:resource key="deleteX" js="true"/>);
			if (!confirm(m.format([name]))) return;
		}
		
		dojo.xhrPost({
			url: '<c:url value="/delete_project.do"/>',
			content: {
				guid: guid,
				token: '${user.token}'
			},
			handleAs: 'json',
			load: didDelete,
			error: onGenericXhrError
		});
		
		function didDelete(result)
		{
			if (!result.success)
			{
				showErrorNote(<change:resource key="deleteFailedTitle" js="true"/>, result.message);
				return;
			}
			
			setDirty(false);
			gTree.deleteByGuid(guid);
			gTree.setLastClicked(null);
			$$('#project').empty();
			showIntro();
		}
	}
	
	function onNewSubproject(e)
	{
		dojo.stopEvent(e);
		
		var parentGuid = $('guid').value;
		newProjectOrSubproject(parentGuid);
	}
	
	function onNewProject(e)
	{
		dojo.stopEvent(e);
		newProjectOrSubproject();
	}
	
	<%-- 
		Makes an ajax call to create a new project or subproject
		and show its HTML.
		parentGuid - if you want a subproject, this should be its parent's GUID. Otherwise, null.
	 --%>
	function newProjectOrSubproject(parentGuid)
	{
		if (!canChangeProject(gTree.lastClicked))
		{
			return;
		}
		 
		// Loading a project with no name will return a blank project template
		var content = {
			token: '${user.token}'
		};

		if (parentGuid) content.parentGuid = parentGuid;
		
		dojo.xhrGet({
			url: '<c:url value="/project.do"/>',
			content: content,
			load: didLoadProject,
			error: onGenericXhrError
			});
		
		function didLoadProject(html)			
		{
			showProjectHtml(html);
			$('name').focus();
			$('name').select();
			gTree.lastFocused && gTree.lastFocused.setSelected(false);
			gTree.setLastClicked(null);
			
			gProjectIsNew = true;
		}
	}
	
	<%-- Slits a user or groups field into an array of names. Splits around commas. --%>
	function splitUsers(users)
	{
		users = dojo.trim(users);
		users = users.split(/\s*,\s*/);
		var duplicates = {};
		
		users = dojo.filter(users, function(user) {
			if (user.length < 1) return false;
			
			if (duplicates[user]) return false;
			duplicates[user] = true;
			
			return true;
		});
		return users;
	}
	
	function convertAttributesToJson()
	{
		// Rules are made of AND rules, that are all ANDed together.
		// An AND rule is made of one or more OR rules that are ORed together.
		// So several AND rules is really a list of single OR rules, e.g., [[OR], [OR]]
		// 
		// This function returns the AND rules, that top level list of lists.
		
		var andRules = [];

		$$('#rules > tr').forEach(function(row) {
			
			var orRules = [];
			var attrName = SelectUtils.getSelectedValue(
				$$('.attribute-select', row)[0]
				);
			
			var i = 0;
			$$('.value-node select, .value-node input', row).forEach(function(valueNode) {
				var attrValue = valueNode.nodeName == 'SELECT' ?
					SelectUtils.getSelectedValue(valueNode) :
					valueNode.value;

				var parent= valueNode.parentNode;
				var guid = "";
				
				if ((parent != null) &&  (dojo.hasAttr(parent, 'guid')))
				{
					guid = dojo.attr(parent, 'guid');
				}

				orRules.push({
					name: attrName,
					value: attrValue,
					guid: guid
				});
			});
			
			var andRule = {
					orRules: orRules,
					guid: row.id
				};

			andRules.push(andRule);
		});
		
		return andRules;
	}

	function convertRolesToJson()
	{
		// Iterate over all the users and groups
		var roles = [];

		$$('#roles > tr').forEach(function(row) {
				
			var users = $$(row.cells[0]).query('input')[0].value;
			users = splitUsers(users);
			
			var role = SelectUtils.getSelectedValue(
				$$(row.cells[1]).query('select')[0]);
			
			var projectRole = {
				members: users,
				role: role,
				guid: row.id
			};
			
			 roles.push(projectRole);
		});
		
		return roles;
	}
	
	function convertProjectToJson()
	{
		var project = dojo.formToObject($('basic-project-info'));
		var rulesDone = false;
		
		// Split admins, editors on commas to send real array to server.
		project.admins = splitUsers(project.admins);
		project.editors = splitUsers(project.editors);
		
		var isAdmin = 'true' == $('is-admin').value;
		var isEditor = 'true' == $('is-editor').value;
		
		if (isAdmin)
		{
			project.rules = convertAttributesToJson();
			rulesDone = true;
		}
		
		if (isEditor)
		{
			if (!rulesDone)
			{
				project.rules = convertAttributesToJsonIfReadOnly();
			}
			
			project.roles = convertRolesToJson();
		}

		return dojo.toJson(project, true);
	}

	//This method is used to convert attributes of a project to a
	//JSON data structure when "CRs Included in this Project" is
	//read only in case of editors.
	function convertAttributesToJsonIfReadOnly()
	{
		var andRules = [];

		$$('#rules > tr').forEach(function(row)
		{
			var orRules = [];
			var attrName = row.cells[0].innerHTML;
			var attrValue = row.cells[1].innerHTML;
			orRules.push({
				name: dojo.trim(attrName),
				value: dojo.trim(attrValue)});

			var andRule = {
						orRules: orRules
					  };
			
			andRules.push(andRule);
		});
		
		return andRules;
	}
	
	function hideNote(animate)
	{
		var note = $('note');
		if (!note) return;
		
		if (animate)
		{
			dojo.fadeOut({
				node: note,
				onEnd: function() {
					note.style.display = 'none';
				}
				}).play();
		}
		else
		{
			note.style.display = 'none';
		}
	}

	function escapeHtml(string)
	{
		var el = document.createElement('div');
		el.appendChild(document.createTextNode(string));
		return el.innerHTML;
	}
	
	<%-- Shows a status note after save or error --%>
	function showNote(title, message, isError)
	{
		// Keep an ID (count) for each note. This is used
		// when a note is auto-closed. We don't auto-close a note
		// if it's ID/count doesn't match what we expect.
		showNote.count = showNote.count ? showNote.count + 1 : 1;
		var lastCount = showNote.count;
		
		var note = $('note');
		if (!note) return;
		
		// If we faded this out, restore the opatcity now.
		dojo.style(note, {
			display: '',
			opacity: 1
		});
		
		// Make sure the user sees it.
		note.scrollIntoView();
		
		$('error-icon').style.display = isError ? '' : 'none';
		$('note-subject').innerHTML = escapeHtml(title);
		if (message)
		{
			$('note-body').style.display = '';
			$('note-body').innerHTML = escapeHtml(message);	
		}
		else
		{
			$('note-body').style.display = 'none';
		}
		
		if (!isError)
		{
			// Auto-close non-errors since they're transient info
			// and can be confusing if an old message is still showing
			// (e.g., did I just save, or is that from before?).
			window.setTimeout(function() {
				if (showNote.count == lastCount)
				{
					hideNote(true);
				}
			}, 5000);
		}
	}

	function showErrorNote(title, message)
	{
		showNote(title, message, true);
	}
	
	function onSaveProject(e)
	{
		// Assumes project is already showing; no IDs should come back undefined.
		var guid = $('guid').value;
		var parentGuid = $('parent-guid').value;
		var name = $('name').value;
		if (!guid) return;
		
		hideNote();
		var projectJson = convertProjectToJson();
		
		var content = {
			'token': '${user.token}',
			'project': projectJson
		};
		
		if (parentGuid) content.parentGuid = parentGuid;
		
		dojo.xhrPost({
			url: '<c:url value="/save_project.do"/>',
			content: content,
			handleAs: 'json',
			load: didSave,
			error: function(error) {
				hideSpinner();
				$('save').disabled = false;
				showErrorNote(<change:resource js="true" key="projectNotSavedTitle"/>, error);
			}
		});
		
		$('save').disabled = true;
		
		function didSave(result)
		{
			$('save').disabled = false;
			$('saved-project-links').style.display = '';

			if (result.success)
			{
				<%-- If not an admin, we need to refresh this view down below. That will overwrite this message anyway, so skip it. --%>
				if (result.isAdmin)
				{
					var m = new MessageFormat(<change:resource js="true" key="savedX"/>);
					showNote(m.format([name]));
				}
			}
			else
			{
				showErrorNote(<change:resource js="true" key="projectNotSavedTitle"/>, result.message);
				return;
			}
			
			if (gProjectIsNew)
			{
				// Add to the tree store to see the project on the left.
				// Create new data store item.
				var projectItem = {
					name: name,
					guid: guid,
					children:[]
				};
				
				if (parentGuid)
				{
					// Jump through hoops to find the parent item and add it to the
					// optional "parenInfo" used when adding the new item below.
					var parentItem;
					gTree.model.store.fetch({
						query: {guid: parentGuid},
						queryOptions: {deep: true},
						onItem: function(item) {
							parentItem = item;
						}
					});
					
					if (parentItem) var parentInfo = {
						parent: parentItem,
						attribute: 'children'
					};
				}
			
				gTree.model.store.newItem(projectItem, parentInfo);
				if (parentGuid)
				{
					var treeNodeMap = gTree._itemNodesMap[parentGuid];
					treeNodeMap[0].expand();
				}
								
				// XXX: private API. Replace with setting 'path' attr in dojo 1.4
				var treeNodes = gTree._itemNodesMap[guid];
				gTree.focusNode(treeNodes[0]);
				gTree.setLastClicked(treeNodes[0]);			
				
			}
			else
			{
				// If the name was modified, update that name in the tree right away.
				gTree.model.store.fetch({
					query: {'guid': guid},
					queryOptions: {deep: true},
					onItem: function(item) {
						if (item.name != name)
						{
							gTree.model.store.setValue(item, 'name', name);
						}
					}
				});
			}

			loadProjectIfGuidIsAvailable(guid);
			setDirty(false);
		}
	}
	
	function canChangeProject(lastClickedItem)
	{
		// the last clicked item should be the item from the tree
		// store for that last tree node (project) that was selected. Can be undefined.
		if (!gProjectIsDirty) return true;
		
		// The focused project has unsaved changes.
		// TODO: show dialog with Save, Don't Save, Cancel options instead???
		var bestName = (lastClickedItem == null) ? $('name').value : lastClickedItem.label;
		var m = new MessageFormat(<change:resource js="true" key="discardChangesToX"/>);
		var discard = confirm(m.format([bestName]));
		
		if (discard && gProjectIsNew)
		{
			gTree.deleteByGuid($('guid').value);
		}
		
		return discard;
	}
	
	<%-- The project tree object is global since its used quite often. --%>
	var gTree;
	
	<%-- Creates the dojo project tree and adds proper event handlers. --%>
	function initTree()
	{
		var store = new dojo.data.ItemFileWriteStore({
			data: ${projectsJson}
		});

		var treeModel = new dijit.tree.ForestStoreModel({
			store: store,
			rootId: "root",
			rootLabel: <change:resource js="true" key="projects"/>,
			childrenAttrs: ["children"]
		 });

		gTree = new dijit.Tree({
			model: treeModel,
			showRoot: false,
			persist: false
		}, "tree");
		
		<%-- 
		// Convenience function to set the focus to the last clicked node.
		// Used to revert to previously focused project if user tries to change project
		// before saving. --%>
		gTree.focusLastClicked = function() {
			this.focusNode(this.lastClicked);
		};
		
		<%-- 
		// To prevent the user from changing projects before saving, we need
		// to intercept the functions that switch nodes in a tree. This is done
		// when clicking a node or navigating with keyboard and clicking 'enter'.
		// In both cases we save the old function and call it IF the user can change
		// project (which might involve prompting them to save first). If they can change,
		// just call the old function to allow the focus to switch to a new project.
		// Otherwise, refocus on the last clicked project. --%>
		var old_onClick = gTree._onClick;
		gTree._onClick = function(e) {
			if (canChangeProject(this.lastClicked))
			{
				setDirty(false);
				return old_onClick.apply(gTree, arguments);
			}
			else
			{
				dojo.stopEvent(e);
				this.focusLastClicked();
			}
		};
		
		<%-- Same as above, but for 'enter' key. --%>
		var old_onEnterKey = gTree._onEnterKey;
		gTree._onEnterKey = function(message) {
			if (canChangeProject(this.lastClicked))
			{
				setDirty(false);
				return old_onEnterKey.apply(gTree, arguments);
			}
			else
			{
				this.focusLastClicked();
			}
		};
		
		dojo.connect(gTree, 'onClick', changeProject);
		
		<%-- We give the "last clicked" project a special (bold?) highlight
		to make it more visible and differentiate it from the standard dojo
		highlighting that moves with the arrow keys even before hitting enter.
		 --%>
		gTree.setLastClicked = function(treeNode) {
			if (this.lastClicked)
			{
				dojo.removeClass(this.lastClicked.labelNode, 'last-clicked');
			}
			
			if(treeNode!= null)
			{
				dojo.removeClass(treeNode.rowNode, 'dijitTreeRowSelected');
				dojo.addClass(treeNode.labelNode, 'last-clicked');
			}
			this.lastClicked = treeNode;
		};
		
		<%-- Track the "last clicked" after each click (also fires on 'enter' key). --%>
		dojo.connect(gTree, 'onClick', function(item, treeNode) {
			this.setLastClicked(treeNode);
		});

		<%-- Convenience to delete directly on tree, not item store --%>
		gTree.deleteByGuid = function(guid)
		{
			gTree.model.store.fetch({
				query: {'guid': guid},
				queryOptions: {deep: true},
				onItem: function(item) {
					gTree.model.store.deleteItem(item);
				}
			});
		}
		
		<%-- If the root node is empty it will not be expanded and any projects
		we add will be invisible (since root node is hidden). Just expand it now,
		even if there is nothing to see, so that the first project we add will be visible. --%>
		gTree.rootNode.expand();
		
		<%-- Clear the initialy selected node. No project is loaded by default. --%>
		gTree.lastFocused && gTree.lastFocused.setSelected(false);
	}
	
	<%-- Manages two SELECT lists, allowing source items to be moved to and from the destination list. --%>
	function ListPicker(sourceList, destList, addButton, removeButton)
	{
		this.setSourceList(sourceList);
		this.destList = destList;
		
		dojo.connect(addButton, 'onclick', this, 'add');
		dojo.connect(removeButton, 'onclick', this, 'remove');
		dojo.connect(destList, 'ondblclick', this, 'remove');
	}
	
	ListPicker.prototype.setSourceList = function(select)
	{
		if (this.sourceHandle) dojo.disconnect(this.sourceHandle);
		this.sourceList = select;
		this.sourceHandle = dojo.connect(this.sourceList, 'ondblclick', this, 'add');
		
	};
	
	ListPicker.prototype.add = function()
	{
		if (SelectUtils.copyOptions(this.sourceList, this.destList))
		{
			disableOkButton(false);
		}
	};
	
	ListPicker.prototype.remove = function()
	{
		if (SelectUtils.copyOptions(this.destList, this.sourceList))
		{
			SelectUtils.removeSelected(this.destList);
			disableOkButton(false);
		}
	};
	
	function onFavAttributesOk()
	{
		dijit.byId('fav-attributes-dialog').hide();
		
		// Save which attribute  were disabled before adding new any new one.
		// We don't want to auto select one that was disabled.
		var wasDisabled = getInheritedAttributes();
		if (gLastSelect)
		{
			for (var i = 0; i < gLastSelect.options.length; i++)
			{
				var option = gLastSelect.options[i];
				if (option.disabled) wasDisabled[option.value] = true;
			}
		}
		
		var newFavs = SelectUtils.getValues($('attribute-picker-chosen'));
		
		// Add all the currently in use attributes to the list so they
		// don't get blasted even if user didn't ask for them.
		// OK if there are duplicates since they get filtered out on set.
		$$('#rules .attribute-select').forEach(function(select) {
			newFavs.push(SelectUtils.getSelectedValue(select));
		});
		
		// Update favs
		gFavoriteAttributes.set(newFavs);

		var selectedAttributes = SelectUtils.getSelectedOptions($('attribute-picker-chosen'));
		
		// Select the new attribute if we can
		if (gLastSelect && selectedAttributes.length >= 1)
		{
			var newAttribute = selectedAttributes[0].value;
			if (!wasDisabled[newAttribute])
			{
				SelectUtils.selectValue(gLastSelect, newAttribute);
				// Fake onchange event since that doesn't fire after programatic change of selectedIndex
				attributeDidChange(gLastSelect);
			}
		}
		
		enableDisableAttributes();
	}

	function hasModifications(isModified)
	{
		if (!${inUserInterface})
		{
			parent.parent.parent.subbuttonbar.isProjectDataModified = isModified;
		}
	}

	TypeFragments.dependentListboxOnclick = function(value)
	{
		window.field = document.getElementById(value);

		var attributeName = value;
		var hashIndex = value.lastIndexOf("#");

		if (hashIndex != -1)
		{
			attributeName = value.substring(value, hashIndex);
		}

		var url = "<change:wsletExpander><!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SERVLET_PATH VALUE=PTWEB_SERVLET --><!-- /WSLET --></change:wsletExpander>" +
	    "?ACTION_FLAG=dependent_listbox_form" +
		  "&TEMPLATE_FLAG=QueryDependentListbox" +
		  "&attributeName=" + escape(attributeName) +
		  "&SUPP_attributeName=" + escape(attributeName) +
		  "&SUPP_attributeLabel=" + escape(attributeName) +
		  "&role=" + escape(role) +
	    "&token=" + token;

	    document.open(url, "listboxDependent", 'resizable,scrollbars,width=700,height=300').focus();
	}

	// Change in value of listbox should change the 
	// color of save button to 'red'.
	TypeFragments.onValueChange = function()
	{
		setDirty(true);
	}

	dojo.addOnLoad(function() {
		initTree();
		
		$$('#new-project,#intro-new-project').onclick(onNewProject);
		dojo.connect(document, 'onclick', onClickDoc);
		
		dojo.connect($('save'), 'onclick', onSaveProject);
		
		AvailableUsers.init();
		AvailableGroups.init();
		
		// Connect Find Users/Groups dialog
		var userPicker = new ListPicker($('user-search-results'), $('user-or-group-search-chosen'), $('add-to-list'), $('remove-from-list'));
		
		// Since the Users and Groups tabs use different SELECT boxes (to retain separate search results)
		// the SELECT wuserP copy from (to the chosen list) can vary. Just set the proper "source list"
		// whenever we switch tabs.
		dojo.connect(AvailableUsers, 'showSearch', function() {
			userPicker.setSourceList($('user-search-results'));
		});
		dojo.connect(AvailableGroups, 'showSearch', function() {
			userPicker.setSourceList($('group-search-results'));
		});

		$$('#cancel-find').onclick(hideFindDialog);
		$$('#ok-find').onclick(onFindOk);
		
		// Connect More/Favorite attributes dialog
		var attributesPicker = new ListPicker(
			$('attribute-picker-available'),
			$('attribute-picker-chosen'),
			$('attribute-picker-add'),
			$('attribute-picker-remove'));
		

		$$('#fav-attributes-cancel').onclick(function() {
			dijit.byId('fav-attributes-dialog').hide();
			});
		$$('#fav-attributes-ok').onclick(onFavAttributesOk);
		
		document.body.style.visibility = 'visible';
		
		loadProjectIfGuidIsAvailable("${guid}");
	});
	
	window.setRoles = function(roles) {
		console.log(roles);
		gRoles =  dojo.map(roles, function(role) {
			return role.name;
		});
		
		$$('#project .role-select').forEach(function(select) {
			updateRoleSelect(select);
		});
	};

	function loadProjectIfGuidIsAvailable(projectGuid)
	{
		if (projectGuid != "")
		{		
			//loads the project details on the page.
			loadProjectByGuid(projectGuid);

			//Highlight the loaded project in the menu tree.
			if (gTree != null)
			{
				var treeNodes = gTree._itemNodesMap[projectGuid];

				if (treeNodes != null || treeNodes != undefined)
				{
					gTree.focusNode(treeNodes[0]);
					gTree.setLastClicked(treeNodes[0]);
				}
			}
		}
	};

	//Reset the dirty flag
	hasModifications(false);
})();


</script>

</head>
<body id="viewContent" CLASS="claro" style="visibility: hidden;">
	
	<table style="display: none;">
		<tr id="role-row-template">
			<td class="users-cell">
				<input class="users-list" type="text" value="">
				
				<a href="#" class="find-users-groups">
					<img class="find-users-groups" alt="<change:resource key="altTextStartQuery"/>" src="<change:urlCreator webResource="PTIMAGES"/>smallStartQuery.gif">
				</a>
			</td>
			<td>
				<select class="role-select"></select>
			</td>
			<td style="border-left: solid 1px gray;">
				<a href="#" class="add-role" title="<change:resource key="addProjectMembersTooltip"/>"><change:resource key="addAclRuleAction"/></a>
				|
				<a href="#" class="delete-role" title="<change:resource key="removeProjectMembersTooltip"/>"><change:resource key="deleteAclRuleAction"/></a>
			</td>
		</tr>
	</table>

	<table style="display: none;">
	<tbody id="attribute-table-template">
		<tr id="attribute-row-template">
			<td>
				<div>
					<select id="current-attr-select" class="attribute-select"></select>
				</div>
			</td>
			<td style="white-space: normal;">
				<span class="or-node">
					<span class="or" style="visibility: hidden;">
						<change:resource key="projectRuleValueDividerOr"/>&nbsp;
					</span>
					
					<span class="value-node"></span>&nbsp;<a href="#" class="minus delete-or-attribute"
					><img alt="<change:resource key='alt00165'/>" title="<change:resource key="removeProjectAttributeValueTooltip"/>"
						class="delete-or-attribute" src="<change:urlCreator webResource="PTIMAGES"/>minus_box.gif"></a>
					
					<a href="#" class="plus add-or-attribute"
					><img alt="<change:resource key='alt00164'/>" title="<change:resource key="addProjectAttributeValueTooltip"/>"
						class="add-or-attribute" src="<change:urlCreator webResource="PTIMAGES"/>plus_box.gif"></a>
					
				</span>

			</td>
			<td style="border-left: solid 1px gray;">
				<a href="#" class="add-attribute" title="<change:resource key="addProjectAttributeTooltip"/>"><change:resource key="addAclRuleAction"/></a>
				<span class="disabled-add-attribute" title="<change:resource key="disabledAddProjectAttributeTooltip"/>">
					<change:resource key="addAclRuleAction"/>
				</span>
				|
				<a href="#" class="delete-attribute" title="<change:resource key="removeProjectAttributeTooltip"/>"><change:resource key="deleteAclRuleAction"/></a>
			</td>
		</tr>
	</tbody>
	</table>

	<div dojoType="dijit.layout.BorderContainer" design="sidebar" style="width: 100%; height: 100%; margin: 0; padding: 0;" gutters="false">
		
		<div dojoType="dijit.layout.ContentPane"
			region="left"
			splitter="true"
			class="content-pane sidebar">
			
			<c:if test="${not inUserInterface}">
				<div class="barHeading">
					<c:if test="${not inUserInterface}">
						<a style="float: right;" href="#" id="new-project" title="<change:resource key="newProjectTooltip"/>">
							<change:resource key="lbl01102"/>
						</a>
					</c:if>
					<change:resource key="projects"/>
				</div>
			</c:if>
			
			<div id="tree" showRoot="false">
				<!-- add via javascript -->
			</div>
			
		</div>

		<div dojoType="dijit.layout.ContentPane"
			region="center"
			class="content-pane"
			id="project-pane">
			
			<img style="display: none;" id="spinner" src="<change:urlCreator webResource="PTIMAGES"/>spinningWait13px.gif">
			
			<div id="project">
			</div>
			
			<div id="intro" class="help-text">
				
				<div id="intro-text">
					<h1 style="text-align: center;"><change:resource key="noSelectedProject"/></h1>
						
					<c:if test="${inUserInterface}">
						<p>
							<change:resource key="noSelectedProjectTextNonAdmin"/>
						</p>
					</c:if>
					<c:if test="${not inUserInterface}">
						<p>
							<change:resource key="noSelectedProjectText"/>
						</p>
					</c:if>
				</div>
			</div>
		</div>
	
		<div dojoType="dijit.layout.ContentPane"
			region="bottom"
			style="text-align: center; margin: 0; padding: 0 4px 4px 4px; Xborder-left: solid #ddd 1px; visibility: hidden;"
			class="content-pane"
			id="save-pane">
			<hr>
			<button id="save" type="button">
				<change:resource key="lbl00592"/>
			</button>
		</div>

	</div>

	<%@ include file="user_or_group_search_dialog.jspf" %>
	
	<%@ include file="favorite_attributes_dialog.jspf" %>
	
</body>
</html>
