<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- pt/forms/migrate.jsp -->
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change"%>

<!-- /* -->
<!-- * IBM and/or HCL Confidential
<!-- * (C) Copyright IBM Corp. 2020.  All Rights Reserved.
<!-- * (C) Copyright HCL Technologies Ltd. 2021.  All Rights Reserved.
<!-- *
<!-- *  The source code for this program is not published or otherwise
<!-- *  divested of its trade secrets, irrespective of what has been
<!-- *  deposited with the U.S. Copyright Office.
<!-- */ -->

<html>
<head>
<title><change:resource key="migrateTitle"/></title>

<link rel="stylesheet" type="text/css" href="<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css">
<link rel="stylesheet" type="text/css" href="<change:urlCreator webResource='JS'/>dojo/dijit/themes/claro/claro.css">

<style type="text/css">
	<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM NAME=styles/default.css -->
		<!-- PARAM NAME=styles/note.css -->
		<!-- /WSLET -->
	</change:wsletExpander>	

	#wrapper {
		/* center the page */
		width: 48em;
		margin: 0 auto;
	}

	th {
		text-align: right;
	}
	
	th, td {
		padding: 2px;
	}

	.box {
		margin: 15px auto;
		border: solid 1px gray;
		background-color: #f7f7f7;
	}

	.box th {
		font-weight: normal;
	}
	
	.box .content, .box .status
	{
		padding: 7px;
	}

	h1.title {
		background: #C2CCDC;
		color: #006;
		
		color: white;
		background: url(<change:urlCreator webResource="PTIMAGES"/>top_bg.png) left -13px;
		
		padding: 5px;
		margin: 0;
	}
	
	.title a
	{
		color: white;
		float: right;
	}

	#error-icon {
		top: 2px;
		margin-right: 2px;
	}

	input.button {
		margin-top: 5px;
	}

	form {
		margin: 0;
	}
	
	.note {
		width: 100%;
	}

	.help-text p, .help-text li{
		color: gray;
	}

	#database {
		width: 100%;
	}
</style>
</head>

<body>

<div id="wrapper">
	
	<h1 class="title">
		<a HREF="javascript: help();">
			<change:resource key="lbl01070"/>
		</a>
		<change:resource key="migrateHeader"/>
	</h1>

	<div class="help-text">
		<change:resource key="migrateHelpText"/>
	</div>
	
	<%--	The box with controls. Hide the whole section if we're not looking at a dev database and there is no active progress. --%>
	<c:if test="${not empty databases or not empty progress}">
		<div class="box">
			<div id="controls" class="content">
				<form id="form">
					<table align="center">
						<tr>
							<th><change:resource key="migrateFromDatbase"/></th>
							<td>
								<select id="database">
									<c:forEach var="db" items="${databases}">
										<option value="${db.name}" <c:if test="${db.name == selectedDatabase}">selected</c:if>>
											${db.name}
										</option>
									</c:forEach>
								</select>
							</td>
						</tr>

						<tr>
							<th>
								<!-- spacer -->
							</th>
							<td>
								<input id="do-email" type="checkbox" title="<change:resource key="migrateEmailTooltip"/>">
								<label for="do-email"><change:resource key="migrateEmail"/></label>
								<input id="email" type="text" size="33" value="${email}" disabled>
							</td>
						</tr>

						<tr align="right">
							<td colspan="2">
								<input id="migrate" class="button" type="submit" value="Migrate" disabled>
								<input id="cancel" class="button" type="button" style="display: none;" value="Stop">
							</td>
						</tr>
					</table>
				</form>
			</div> <!-- end controls -->

			<div id="status" class="content soria"
				<c:if test="${empty progress}">
					style="display: none"
				</c:if>
				>

				<hr noshade size="1">

				<change:resource key="migrateInProgress"/>
				<div dojoType="dijit.ProgressBar" id="bar" style="width: 98%;" indeterminate="true"></div>
				<span id="progress-message">
					<!-- completed x of y... -->
				</span>
			</div> <!-- end status/progress -->


		</div> <!-- end box -->
	</c:if>
	
	<div class="note" id="note" style="display: none;">
		<h1>
			<img id="error-icon" alt="<change:resource key='altTextWarning'/>" src="<change:urlCreator webResource="PTIMAGES"/>warning_small.gif">
			<span id="note-subject"></span>
		</h1>
		<p id="note-body"></p>
	</div>
</div>

<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
<script type="text/javascript" src="<c:url value="/dwr/interface/MigrateServiceAjax.js"/>"></script>
<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
 
<script type="text/javascript">
	<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM NAME=SelectUtils.js -->
		<!-- PARAM NAME=MessageFormat.js -->
		<!-- /WSLET -->
	</change:wsletExpander>	

	dojo.require('dojo.parser');
	dojo.require('dijit.ProgressBar');
	
	// shortcuts like prototype.js
	var $ = dojo.byId;
	var $$ = dojo.query;
	
	function isValid(url)
	{
		if ((url).match(/^(http[s]?):.*/) == null)
		{
		  return false;								
		}
		
		return true;
	}

	function help(e)
	{
		var url = "<change:serverProperty property="HELP_SERVER_URL"/>";

		if(isValid(url))
		{
			url=url+"?"+"<change:serverProperty property="SYSTEM_LOCALE"/>"+"&topic=/com.ibm.rational.change.admin.doc/topics/ch_t_ha_mig_cr_to_cntrl_srv_ms.html";
			document.open(url);
		}
		else
		{
			url= "<change:urlCreator webResource="TRAPEZE"/>"+url;
			document.open(url);
		}
	}
	
	var gCancelled = false;
	
	/**
	 * Starts a migrate. Shows the progress bar et al. If migrate starts successfully,
	 * starts polling for progress until done.
	 */
	function onMigrate(e)
	{
		dojo.stopEvent(e);
		
		// show progress bar, but don't allow a cancel until the operation starts--
		// we can't cancel that early.
		showProgress();
		hideNote();
		$('cancel').disabled = true;
		gCancelled = false;
		
		// ping the central with a relatively short timeout to ensure it's there.
		// Only then do we start the--potentially--long wait for the migrate to start.
		MigrateServiceAjax.ping('${token}', {
			callback: pingDidReturn,
			errorHandler: showErrorNote,
			timeout: 30 * 1000
		});

		function pingDidReturn()
		{
			MigrateServiceAjax.migrateFrom(
				'${token}',
				SelectUtils.getSelectedValue('database'),
				$('do-email').checked ? $('email').value : null,
				{
					callback: migrateDidStart,
					errorHandler: showErrorNote,
					timeout: 10 * 60 * 1000
				}
			);
		}
		
		function migrateDidStart(prog)
		{
			var myDatabase = SelectUtils.getSelectedValue('database');

			if (myDatabase != prog.database)
			{
				SelectUtils.selectValue('database', prog.database, true);
				var xInProgress = new MessageFormat('<change:resource key="migrateXAlreadyInProgress"/>');
				
				showNote(
					'<change:resource key="migrateAlreadyInProgress"/>',
					xInProgress.format(prog.database));
			}

			pollProgress(prog);
			$('cancel').disabled = false;
		}
	}
	
	function hideNote()
	{
		$('note').style.display = 'none';
	}

	function escapeHtml(string)
	{
		var el = document.createElement('div');
		el.appendChild(document.createTextNode(string));
		return el.innerHTML;
	}
	
	function showNote(title, message, isError)
	{
		hideProgress();

		$('note').style.display = '';
		$('error-icon').style.display = isError ? '' : 'none';
		$('note-subject').innerHTML = escapeHtml(title);
		$('note-body').innerHTML = escapeHtml(message);
	}

	function showErrorNote(message)
	{
		showNote('<change:resource key="migrateFailed"/>', message, true);
	}
	
	/**
	 * Updates the progress bar and the progress message.
	 * @param bar progress bar widget to update.
	 * @param prog a MigrateProgress object with current progress details.
	 */
	function updateProgressBar(bar, prog)
	{
		var message = new MessageFormat('<change:resource key="migrateCompletedXOfXTimeX"/>');
		// support HTML in the message string
		$('progress-message').innerHTML = message.format([
			prog.completedCrs,
			prog.totalCrs,
			prog.timeRemaining
			]);

		bar.update({
			progress: prog.completedCrs,
			maximum: prog.totalCrs || 1,	// make sure we're never zero or IE will have a div by zero error.
			indeterminate: false
			});
	}
	
	function updateControls(prog)
	{
		SelectUtils.selectValue('database', prog.database, true);
		if (prog.emailAddress)
		{
			$('do-email').checked = true;
			$('email').value = prog.emailAddress;
		}
	}

	/** The window.setTimeout ID of the backgound poll for progress. */
	var pollId;
	
	/**
	 * Periodically polls for updates to the progess in the background
	 * and updates the progress bar accordingly.
	 * Will auto-hide the progress bar when the migrate is over.
	 * 
	 * This looks like it makes a lot of server call, but it is limited
	 * by how fast the server resonds, which isn't very often for a real migrate.
	 * @param prog
	 *		a progress object like the MigrateProgress class.
	 *		Expects properties for completedCrs, totalCrs, database, and time remaining.
	 */
	function pollProgress(prog)
	{
		// update controls if we're continuing an existing migrate
		updateControls(prog);
		
		var bar = dijit.byId('bar');
		updateProgressBar(bar, prog);

		pollOnce();

		function pollOnce()
		{
			window.clearTimeout(pollId);
			pollId = window.setTimeout(function() {
				MigrateServiceAjax.awaitProgress('${token}', prog.database, 2 * 60 * 1000, {
					callback: progressDidOccur,
					errorHandler: showErrorNote
				});
			}, 100);
		}

		function progressDidOccur(newProg)
		{
			if (!pollId) return; // was canceled

			// match what the server said in case we're continuing an existing migrate
			updateControls(newProg);

			if (newProg.finished || newProg.canceled)
			{
				gCancelled = false;
				hideProgress();
				var noteTitle = newProg.canceled
					? '<change:resource key="migrateStopped"/>'
					: '<change:resource key="migrateSucceeded"/>';
				var noteMessage = new MessageFormat('<change:resource key="migratedXFromX"/>');
				showNote(
					noteTitle,
					noteMessage.format([newProg.completedCrs, newProg.database]));
			}
			else
			{
				// If we're canceled, we're waiting for a "canceled" progress object,
				// so don't bother updating progress bar yet.
				if (!gCancelled) updateProgressBar(bar, newProg);
				pollOnce();
			}
		}
	}
	
	/** Show the progress bar et al. Does not start polling. */
	function showProgress()
	{
		$$('#database, #do-email, #email, #migrate').attr('disabled', true);
		$('migrate').style.display = 'none';

		// show progress stuff
		$('status').style.display = '';
		$('progress-message').innerHTML = '<change:resource key="gettingReady"/>';
		$('cancel').style.display = '';
		$('cancel').disabled = false;
	}

	/** Hide progress bar et al. Stop polling if it was active. */
	function hideProgress()
	{
		if (!$('controls')) return;

		// reshow main controls
		$('migrate').style.display = '';
		$$('#database, #do-email, #migrate').attr('disabled', false);
		$('email').disabled = !$('do-email').checked;

		// hide the "in progress" stuff
		$('status').style.display = 'none';
		$('cancel').disabled = true;
		$('cancel').style.display = 'none';

		// stop polling for progress updates
		window.clearTimeout(pollId);
		gCancelled = false;
		
		dijit.byId('bar').update({
			progress: '0%',
			indeterminate: true
			});
	}

	function onCancel(e)
	{
		dojo.stopEvent(e);

		// intermediate visual state while canceling
		$('cancel').disabled = true;
		$('progress-message').innerHTML = '<change:resource key="stopping"/>';
		dijit.byId('bar').update({
			indeterminate: true
			});
		
		gCancelled = true;
		
		// Now really cancel. There's no callback from the method, but the progress poller
		// will get a new, canceled progress object as a result of this.
		MigrateServiceAjax.cancel('${token}', SelectUtils.getSelectedValue('database'), {
			errorHandler: function() {hideProgress();}
		});
	}
	
	function toggleEmail()
	{
		$('email').disabled = !$('do-email').checked;
		if ($('email').value == 'user@example.com')
		{
			$('email').value = '';
		}
	}
	
	dojo.addOnLoad(function() { 
		<c:choose>
			<c:when test="${empty databases and empty progress}">
				<!-- No dev databases and nothing in progress from another server. Nothing to see here. -->
				showNote(
					'<change:resource key="noMigrateInProgress"/>',
					'<change:resource key="noMigrateInProgressDetails"/>');	
			</c:when>

			<c:otherwise>
				$$('#form').connect('onsubmit', onMigrate);
				$$('#cancel').onclick(onCancel);
				$$('#do-email').onclick(toggleEmail);
				
				<c:if test="${empty progress}">
					hideProgress();
				</c:if>

				<c:if test="${not empty progress}">
					// migrate already in progress, so show it. Need an explicit show
					// here since we start the controls as disabled until all the script loads.
					showProgress();
					$('email').value = '';

					// call poll progress with the an object like a MigrateProgress obj
					// in Java code. This is essentially what ajax calls get back, but
					// we're faking it here from JSP vars to show the progress right away.
					pollProgress({
						database: <change:javaScriptEscape value="${progress.database}"/>,
						emailAddress: <change:javaScriptEscape value="${progress.emailAddress}"/>,
						completedCrs: '${progress.completedCrs}',
						totalCrs: '${progress.totalCrs}',
						timeRemaining: <change:javaScriptEscape value="${progress.timeRemaining}"/>
						});
				</c:if>
			</c:otherwise>
		</c:choose>
	});
</script>

</body>
</html>
