<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\user_framework\create_home_page.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<html>
<head>
	<title></title>
	
	<style type="text/css">

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/default.css -->
	<!-- /WSLET -->
</change:wsletExpander>

img.layout
{
	margin-left: 25px;
	margin-top: 10px;
	margin-bottom: 10px;
}

div.title
{
	margin-bottom: 10px;
}

table td
{
	white-space: nowrap;
}

.dijitTextBox
{
	border: solid #528B8B 1px; 
	#overflow: hidden;
	width: 3.5em;	
	height: 1.75em;
}

.dijitTextBox INPUT
{
	padding:0;
	border-left: solid black 1px;
	display:inline;
	position:static !important;
	border:0 !important;	
	margin:0 !important;
	vertical-align:0em !important;
	visibility:visible !important;
	background-image:none !important;
	width:100% !important;
	text-align: right;
}

.dijitValidationIcon {
	visibility: hidden;
	display: block;
}
.dijitValidationIconText {
	visibility: hidden;
	display: none;
}
.dijitValidationIcon { display: none !important; }
.dijitValidationIconText { display: none !important; }

	</style>

	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	<script type="text/javascript">		
        dojo.require("dijit.form.NumberTextBox");
	</script>
	<script type="text/javascript">
	
<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=subhelp.js -->
	<!-- PARAM NAME=emphasis.js -->
	<!-- /WSLET -->
</change:wsletExpander>

//Global variable to track last clicked page layout
var selectedLayout = "";
var isModified = false;

<c:choose>
<c:when test="${not empty editHomePage}">
	var originalName = <change:javaScriptEscape value="${editHomePage.name}"/>;
</c:when>
<c:otherwise>
	var originalName = undefined;
</c:otherwise>
</c:choose>

function hasModifications()
{
	return window.isModified;
}

<%-- 
	Make sure the user has entered all the necessary information 
	Return true if validated, false otherwise.
--%>
function validate()
{
	//do this first so firefox won't complain about home page title before this.
	if (dojo.byId("specifyCols").checked)
	{
		var firstColWidth = dijit.byId("firstColWidth");
		if(!firstColWidth.isValid())
		{
			alert("<change:resource key='colWidthNotAnInteger'/>");
			firstColWidth.focus();
			//as firstColWidth.select() is not working, use document.getElementById to select the text
			document.getElementById("firstColWidth").select();
			return false;
		}
		
		if(!firstColWidth.isInRange())
		{
			alert("<change:resource key='colWidthNotPositiveOrGreaterThan100'/>");
			firstColWidth.focus();
			//as firstColWidth.select() is not working, use document.getElementById to select the text
			document.getElementById("firstColWidth").select();
			return false;
		}
	}
	
	var homePageTitle = dojo.byId("homePageTitle");
	title = dojo.trim(homePageTitle.value);
	
	if (title.length == 0)
	{
		alert("<change:resource key='missingHomePageTitle'/>");
		homePageTitle.focus();
		return false;
	}
	
	if ((originalName == undefined) || (title.toLowerCase() != originalName.toLowerCase()))
	{
		var homePages;
		
		if (${asAdmin})
		{
			if(parent.navigation.homePages===undefined){
				homePages = parent[0].adminHomePages;
			}else{
				homePages = parent.navigation.adminHomePages;
			}
		}
		else
		{
			if(parent.navigation.homePages===undefined){
				homePages = parent[0].homePages;
			}else{
				homePages = parent.navigation.homePages;
			}
		}
		
		var tempTitle = title.toLowerCase();
		for (var i = 0; i < homePages.length; i++)
		{
			if (homePages[i].toLowerCase() == tempTitle.toLowerCase())
			{
				alert("<change:resource key='homePageNameInUse'/>");
				homePageTitle.value = "";
				homePageTitle.focus();
				return false;
			}
		}
	}
	
	if (window.selectedLayout == "")
	{
		alert("<change:resource key='missingPageLayout'/>");
		return false;
	}
	
	if (window.selectedLayout == "singleRow")
	{
		//finished processing for singleRow layout.
		return true;
	}
	
	return true;
}

<%--
  When one of the radio buttons is selected if the singleRow layout is selected
  then hide the specify checkbox and clear the column widths and hide them as well.
--%>
function layoutOnClick(radioButton)
{
	window.selectedLayout = radioButton.value;
	showHideColWidths();
}

function showHideColWidths()
{
	if (window.selectedLayout == "singleRow")
	{
		dojo.byId("columnWidths").style.display = "none";
		dojo.byId("specifyCols").checked = false;
		disableAndClearColWidths();
	}
	else
	{
		dojo.byId("columnWidths").style.display = "";
	}
}

<%--
	When one of the images is clicked it will pass in the radio button name,
	fetch the radio button object and then call layoutOnClick.
--%>
function layoutImageOnClick(radioName)
{
	var radioButton = dojo.byId(radioName);
	
	radioButton.checked = true;
	
	layoutOnClick(radioButton);
}

<%--
  When the specify column widths checkbox is clicked enable the 
  first and second column textfields. Reverse this if unchecked.
--%>
function specifyColsOnClick()
{
	if (dojo.byId("specifyCols").checked)
	{
		dojo.byId("firstColWidth").disabled = false;
		
		//set the background color to back to white when the textbox is not disabled.
		//set it for the text box and the div element which includes the text box.
		//otherwise, the color is not set properly in IE.
		dojo.byId("firstColWidth").style.backgroundColor = "transparent";
		document.getElementById("widget_firstColWidth").style.backgroundColor = "transparent";
	}
	else
	{
		disableAndClearColWidths();
	}
}

function firstColWidthOnBlur()
{
	var firstColWidth = dijit.byId("firstColWidth");
	
	if(!firstColWidth.isValid())
	{
		return;
	}
	if(!firstColWidth.isInRange())
	{
		return
	}
	
	var newValue = 100 - parseInt(firstColWidth.value);
	
	dojo.byId("secondColWidth").innerHTML = newValue;	
}

<%--
  Disable both column width fields and clear their values.
--%>
function disableAndClearColWidths()
{
	var firstColWidth = dojo.byId("firstColWidth");
	firstColWidth.disabled = true;
	firstColWidth.value = "";
	
	//set the background color to gray, sot that the text box looks disabled.
	//set it for the text box and the div element which includes the text box.
	//otherwise, the color is not set properly in IE.
	firstColWidth.style.backgroundColor = "#EBECE4";
	document.getElementById("widget_firstColWidth").style.backgroundColor = "#EBECE4";
			
	var secondColWidth = dojo.byId("secondColWidth");
	secondColWidth.innerHTML = "";
}

function nextOnClick()
{
	if (!validate())
	{
		return;
	}
	
	window.document.createHomePage.token.value = "${user.token}";
	window.document.createHomePage.actionFlag.value = "addReports";
	window.document.createHomePage.homePageTitle.value = dojo.byId("homePageTitle").value;
	window.document.createHomePage.pageLayout.value = window.selectedLayout;
	
	var specifyColumnWidths = dojo.byId("specifyCols");
	
	if (specifyColumnWidths.checked)
	{
		window.document.createHomePage.specifyColumnWidths.value = "true";
		window.document.createHomePage.firstColWidth.value = dojo.byId("firstColWidth").value;
		window.document.createHomePage.secondColWidth.value = dojo.byId("secondColWidth").innerHTML;
	}
	else
	{
		window.document.createHomePage.specifyColumnWidths.value = "false";
	}


	<c:if test="${not empty editHomePage}">
			window.document.createHomePage.originalName.value = <change:javaScriptEscape value="${editHomePage.name}"/>;
	</c:if>

	if (dojo.byId("toAllDatabases").checked)
	{
		window.document.createHomePage.toAllDatabases.value = "true";
	}
	else
	{
		window.document.createHomePage.toAllDatabases.value = "false";
	}	
	
	window.document.createHomePage.submit();
}

function toAllDatabasesOnClick()
{
	if (dojo.byId("toAllDatabases").checked)
	{
		window.document.createHomePage.toAllDatabases.value = "true";
	}
	else
	{
		window.document.createHomePage.toAllDatabases.value = "false";
	}
}

function editMode()
{
	<c:if test="${not empty editHomePage}">
		dojo.byId("homePageTitle").value = <change:javaScriptEscape value="${editHomePage.name}"/>;
		dojo.byId("${editHomePage.pageLayout}").checked = true;
		window.selectedLayout = <change:javaScriptEscape value="${editHomePage.pageLayout}"/>;
		showHideColWidths();
		
		if (${editHomePage.specifiedColumnWidths})
		{
			dojo.byId("specifyCols").checked = true;
			dojo.byId("firstColWidth").disabled = false;
			dojo.byId("firstColWidth").value = <change:javaScriptEscape value="${editHomePage.firstColumnWidth}"/>;
			dojo.byId("secondColWidth").innerHTML = <change:javaScriptEscape value="${editHomePage.secondColumnWidth}"/>;
		}
		var databaseName = <change:javaScriptEscape value="${editHomePage.databaseName}"/>;
		
		if (databaseName == "")
		{
			dojo.byId("toAllDatabases").checked = true;
		}
		
	</c:if>
}

function markUnSaved()
{
	var button = dojo.byId("nextButton");
	emphasizeButton(button);
	
	window.isModified = true;
}

<%-- 
  Function called when the page is loaded.
--%>
function pageLoad()
{
	dojo.byId("homePageTitle").focus();
	dojo.byId("singleRow").checked = true;
	window.selectedLayout = "singleRow";
	disableAndClearColWidths();

	var firstColWidth = dijit.byId('firstColWidth');
	firstColWidth.promptMessage = "";
	firstColWidth.invalidMessage = "";
	firstColWidth.rangeMessage = "";
	
	<c:if test="${editMode == 'true'}">
		editMode();
	</c:if>
	
	dojo.connect("layoutImageOnClick", "markUnSaved");
	dojo.connect("layoutOnClick", "markUnSaved");
	dojo.connect("specifyColsOnClick", "markUnSaved");
	dojo.connect("firstColWidthOnBlur", "markUnSaved");
	dojo.connect("toAllDatabasesOnClick", "markUnSaved");
	
	var homePageTitle = dojo.byId("homePageTitle");
	dojo.connect(homePageTitle, "onkeypress", "markUnSaved");
}

dojo.addOnLoad(pageLoad);

	</script>
</head>
<body>
	<table width="100%" class="barHeading">
	<tr>
	<th>
		<c:choose>
		<c:when test="${editMode == 'true'}">
			<change:resource key='editExistingHomePage'/>
			</c:when>
			<c:otherwise>
				<c:choose>
				<c:when test="${asAdmin}">
					<change:resource key='createDefaultHomePage'/>
				</c:when>
				<c:otherwise>
					<change:resource key='addHomePage'/>
				</c:otherwise>			
			</c:choose>
			</c:otherwise>
		</c:choose>
		
		<span id="name">&nbsp;&#151;&nbsp;<change:resource key='selectPageLayout'/></span>
	</th>
	<th style="text-align: right;">
		<c:choose>
			<c:when test="${asAdmin}">
				<a href="javascript:openHelp('${user.role}', 37)" title="<change:resource key='homePageHelp'/>"><change:resource key="lbl01070"/></a>
			</c:when>
			<c:otherwise>
				<a href="javascript:openHelp('${user.role}', 34)" title="<change:resource key='homePageHelp'/>"><change:resource key="lbl01070"/></a>
			</c:otherwise>
		</c:choose>
	</th>
	</tr>
	</table>

	<div style="margin-left: 10px;">
		<div class="title">
			<label for="homePageTitle" class="label_decoration"><change:resource key='homePageTitle'/>:&nbsp;</label>
			<input style="width: 70%;" type="text" id="homePageTitle">&nbsp;&nbsp;&nbsp;&nbsp;
			<label for="toAllDatabases" class="label_decoration"><change:resource key='homePageDatabase'/>:&nbsp;</label>
			<input type="checkbox" id="toAllDatabases" style="margin-top: 5px;" onClick="toAllDatabasesOnClick(this)">
		</div>
			
		<div class="title">
			<label class="label_decoration"><change:resource key='selectHomePageLayout'/></label>
		</div>
		
		<div style="border: 1px solid gray;">
			<table>
			<tr>
				<td width="33%">
					<input id="singleRow" name="layout" type="radio" value="singleRow" onClick="layoutOnClick(this)">
					<label for="singleRow" class="label_decoration"><change:resource key='singleRow'/></label>
					<br>
					<img src="<change:urlCreator webResource="PTIMAGES"/>singleRow.gif" alt="<change:resource key='altTextsingleRow'/>" class="layout" onclick="layoutImageOnClick('singleRow')"/>
				</td>
				<td width="33%">
					<input id="dualColumn" name="layout" type="radio" value="dualColumn" onClick="layoutOnClick(this)">
					<label for="dualColumn" class="label_decoration"><change:resource key='dualColumn'/></label>
					<br>
					<img src="<change:urlCreator webResource="PTIMAGES"/>dualColumn.gif" alt="<change:resource key='altTextdualColumn'/>" class="layout" onclick="layoutImageOnClick('dualColumn')"/>
				</td>
				<td width="33%">
					<input id="rowDualColumn" name="layout" type="radio" value="rowDualColumn" onClick="layoutOnClick(this)">
					<label for="rowDualColumn" class="label_decoration"><change:resource key='rowDualColumn'/></label>
					<br>
					<img src="<change:urlCreator webResource="PTIMAGES"/>dualRowTop.gif" alt="<change:resource key='altTextdualrowTop'/>" class="layout" onclick="layoutImageOnClick('rowDualColumn')"/>
				</td>
			</tr>
			<tr>
				<td>
					<input id="dualColumnRow" name="layout" type="radio" value="dualColumnRow" onClick="layoutOnClick(this)">
					<label for="dualColumnRow" class="label_decoration"><change:resource key='dualColumnRow'/></label>
					<br>
					<img src="<change:urlCreator webResource="PTIMAGES"/>dualRowBottom.gif" alt="<change:resource key='altTextdualRowBottom'/>" class="layout" onclick="layoutImageOnClick('dualColumnRow')"/>
				</td>
				<td>
					<input id="twoRowDualColumn" name="layout" type="radio" value="twoRowDualColumn" onClick="layoutOnClick(this)">
					<label for="twoRowDualColumn" class="label_decoration"><change:resource key='twoRowDualColumn'/></label>
					<br>
					<img src="<change:urlCreator webResource="PTIMAGES"/>dualColDualRow.gif" alt="<change:resource key='altTextdualColDualRow'/>" class="layout" onclick="layoutImageOnClick('twoRowDualColumn')"/>
				</td>			
			</tr>
			</table>
			
			<div id="columnWidths" style="display: none;">
				<div style="margin-left: 8px;">
					<input type="checkbox" id="specifyCols" style="margin-top: 5px;" onClick="specifyColsOnClick()">
					<label for="specifyCols" class="label_decoration"><change:resource key='specifyColumnWidths'/></label>
					<i>(<change:resource key='columnBestFit'/>)</i>
					<br>
					<table style="margin-left: 25px">
					<tr>
						<td>
							<table>
							<tr>
								<td style="text-align: right">
									<label for="firstColWidth" class="label_decoration"><change:resource key='firstColumnWidth'/>: </label>
								</td>
								<td>
									<input type="text" id="firstColWidth"  dojoType="dijit.form.NumberTextBox" 
											constraints="{min:1,max:99,places:0}"											
											onblur="firstColWidthOnBlur();">
								</td>
								<td>
									%
								</td>
							</tr>
							<tr>
								<td style="text-align: right">
									<label for="secondColWidth" class="label_decoration"><change:resource key='secondColumnWidth'/>: </label>
								</td>
								<td align="right">
									<span id="secondColWidth"></span>
								</td>
								<td>
									%
								</td>
							</tr>
							</table>
						</td>
					</tr>
					</table>
				</div>
			</div>
		</div>

		<div width="100%" style="text-align:center;">
			<br>
			<button type="button" id="nextButton" onClick="nextOnClick()"><change:resource key='lbl00157'/></button>
		</div>
	</div>
	
	<form name="createHomePage" action="<change:urlCreator webResource='BASEURL'/>/createHomePage.do" class="hiddenForm" method="POST" target="_self">
		<input name="token" type="hidden">
		<input name="actionFlag" type="hidden">
		<input name="homePageTitle" type="hidden">
		<input name="toAllDatabases" type="hidden">
		<input name="pageLayout" type="hidden">
		<input name="specifyColumnWidths" type="hidden">
		<input name="firstColWidth" type="hidden">
		<input name="secondColWidth" type="hidden">
		<input name="asAdmin" type="hidden" value="${asAdmin}">
		<input name="editMode" type="hidden" value="${editMode}">
		<c:if test="${not empty editHomePage}">
			<input name="originalName" type="hidden">
		</c:if>
	</form>
</body>
</html>
