/**
 * forgotPassword.js shall contains all utility methods for 
 * forgot password feature 
 * 
 */
 
 /**
 * IBM and/or HCL Confidential
 * (C) Copyright IBM Corp. 2020.  All Rights Reserved.
 * (C) Copyright HCL Technologies Ltd. 2021.  All Rights Reserved.
 *
 *  The source code for this program is not published or otherwise
 *  divested of its trade secrets, irrespective of what has been
 *  deposited with the U.S. Copyright Office.
 */
	/**
	* Perform validation to show change password dialog on page load
	*/ 
	function validateToShowChangePasswordDlg()
	{
		if (showChangePasswordDialog == "true")
		{ 
			writePasswordPolicy(dojo.byId("policyContent"), passwordPolicy);
			dlg = dijit.byId("popupDialog");

			if (!passwordPolicy.checkPasswordSyntax)
			{
				dojo.byId("policy").style.display = "none";
			}
			else
			{
				dojo.byId("policy").style.display = "";
			}

			showPolicyDialog();
		}

		if (showLinkExpiredDialog == "true")
		{ 
			showLinkExpiredMessage();
		}
		
		if (showFeatureDisabledDialog == "true")
		{
			showFeatureDisabledMessage();
		}
	}
	
	/**
	 * Validate e-mail address forgot and make forgot password request AJAX call
	 */ 
	function onSubmit()
	{
		if (dojo.byId("submitBtn").value == "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='lbl01157' --><!-- /WSLET -->")
		{
			hideForgotPasswordDialog();
			return;
		}
	
		var warningsSpan = dojo.byId("forgotPwdWarning");
		var emailId = dojo.trim(dojo.byId("emailId").value);
		var isAdminUrl = false;
		
		if (emailId != "")
		{
			if(typeof userRole == "undefined")
			{
				isAdminUrl = true;
			}
			
			ForgotPasswordUtilsAjax.forgotPasswordRequest(emailId, isAdminUrl, DwrCall.getMetadata(forgotPasswordCallback));
		}
		else
		{
			displayErrorMessage();
			dojo.byId("emailId").focus();
		}			
	}
	
	/**
	 * Hide all the forgot password components and show "OK" button with proper message
	 */
	function submitToOk()
	{
		dojo.byId("forgotPwdWarningMsgs").style.display = "";
		dojo.byId("forgotPwdWarningIcon").style.display = "none";
		dojo.byId("emailId").style.display = "none";
		dojo.byId("emailIdLbl").style.display = "none";
		dojo.byId("cancelBtn").style.display = "none";
		dojo.byId("submitBtn").style.display = "";
		dojo.byId("submitBtn").value = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='lbl01157' --><!-- /WSLET -->";
		dojo.byId("submitBtn").focus();
	}

	/**
	 * Display error message if there are validation errors
	 */ 
	function displayErrorMessage()
	{
		dojo.byId("forgotPwdWarningMsgs").style.display = "";
		dojo.byId("forgotPwdWarningIcon").style.display = "";
		dojo.byId("forgotPwdWarning").style.display ="";
		dojo.byId("forgotPwdWarningMsgs").style.display = "";
		dojo.byId("forgotPwdWarning").innerHTML = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='invalidEmail' --><!-- /WSLET -->";
		dojo.byId("forgotPwdWarningMsgs").style.display = "";
		dojo.byId("emailIdLbl").style.display = "";
		dojo.byId("emailId").style.display = "";	
	}
	
	/**
	 * Shows forgot password dialog
	 */
	function showForgotPasswordDialog()
	{
		dojo.byId("forgotPwdWarningMsgs").style.display = "none";
		dojo.byId("forgotPwdWarningIcon").style.display = "none";
		dojo.byId("emailIdLbl").style.display = "";
		dojo.byId("emailId").style.display = "";
		dojo.byId("emailId").value = "";
		dojo.byId("cancelBtn").style.display = "";
		dojo.byId("forgotPwdWarning").innerHTML = "";
		dojo.byId("submitBtn").style.display = "";
		dojo.byId("submitBtn").value = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='submitButtonLabel' --><!-- /WSLET -->";
		dijit.byId("forgotPasswordDialog").show();
		dojo.byId("forgotPwdMsg").style.display = "";
	}

	/**
	 * Hides forgot password dialog
	 */
	function hideForgotPasswordDialog()
	{
		dijit.byId("forgotPasswordDialog").hide();
	}

	/**
	 * AJAX callback function for forgot password request.
	 */
	function forgotPasswordCallback(result)
	{
		submitToOk();
		dojo.byId("forgotPwdMsg").style.display = "none";
		dojo.byId("forgotPwdWarning").innerHTML = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='forgotPasswordRequestSubmitted' --><!-- /WSLET -->";
	}

	/**
	 * Validate if forgot password link should be visible 
	 */ 
	function isForgotPasswordLinkEnabled()
	{
		if (isForgotPasswordLinkRequired == "true")
		{
			if (dojo.byId("separator"))
			{
				dojo.byId("separator").style.display = "";
			}
			
			dojo.byId("forgotPassword").style.display = "";
		}
		else
		{
			if (dojo.byId("separator"))
			{
				dojo.byId("separator").style.display = "none";
			}
			
			dojo.byId("forgotPassword").style.display = "none";
		}
	}
			
	/**
	* AJAX callback function for password reset operation.
	*/
	function resetPasswordCallBack(errorMessage)
	{
		if (errorMessage == "''")
		{
			dlg.hide();

			dojo.byId("messageDlgHeader").innerHTML = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='passwordChangedTitle' --><!-- /WSLET -->";
			
			var formatter = new MessageFormat("<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='passwordChanged' --><!-- /WSLET -->");
			var message = formatter.format(new Array(user));

			dojo.byId("message").innerHTML = message;
			dojo.byId("messageDlgIcon").style.display = "none";
			dijit.byId("messageDialog").show();
			dojo.byId("okButton").focus();
		}
		else
		{
			dojo.byId("warnings").innerHTML = eval(errorMessage);
			dojo.byId("warningIcon").style.display = "";
			dojo.byId("newPassword").value = "";
			dojo.byId("confirmPassword").value = "";
			dojo.byId("newPassword").focus();
		}
	}
	
	/** 
	 * Shows link expire message dialog 
	 */
	function showLinkExpiredMessage()
	{
		dojo.byId("messageDlgHeader").innerHTML = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='linkExpiredTitle' --><!-- /WSLET -->";
		dojo.byId("message").innerHTML = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='linkExpired' --><!-- /WSLET -->";
		dojo.byId("messageDlgIcon").style.display = "";
		dijit.byId("messageDialog").show();
	}
	
	
	/** 
	 * Shows forgot password feature disabled message dialog 
	 */
	function showFeatureDisabledMessage()
	{
		dojo.byId("messageDlgHeader").innerHTML = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='passwordResetRequestTitle' --><!-- /WSLET -->";
		dojo.byId("message").innerHTML = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='unableToProcessForgotPasswordRequest' --><!-- /WSLET -->";
		dojo.byId("messageDlgIcon").style.display = "";
		dijit.byId("messageDialog").show();
	}
	
	
	/**
	 * Capture event and perform key when enter key is pressed 
	 * @param evt event
	 * @return
	 */
	function emailField_onKeyup(evt)
	{
		if (evt.keyCode == 13)
		{
			onSubmit();
		}
	}
